{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_DefaultPolymorphic ( d_C_defaultPolymorphic ) where

import Basics
import qualified Curry_FiniteMap
import qualified FlatCurry.Annotated.Curry_Goodies
import qualified FlatCurry.Annotated.Curry_TypeSubst
import qualified FlatCurry.Annotated.Curry_Types
import qualified FlatCurry.Curry_Types
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_State


type C_DPM t0 = Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)

d_C_defaultType :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr
d_C_defaultType cd cs = FlatCurry.Curry_Types.C_TCons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "Prelude") (Curry_Prelude.toCurryString "()"))
  Curry_Prelude.OP_List

d_C_defaultPolymorphic :: Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr
d_C_defaultPolymorphic cd cs =
  FlatCurry.Annotated.Curry_Goodies.d_C_updProgFuncs (Curry_Prelude.d_C_map
  d_C_dpFunc) cd cs

d_C_dpFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr
d_C_dpFunc x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> d_C__case_2 x2 x6 x5
    x4 x3 x1 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) (Curry_Prelude.d_C_take (Curry_Prelude.C_Int (6))
    (Curry_Prelude.d_C_snd x2 cd cs) cd cs) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "_impl#") (Curry_Prelude.OP_Cons
    (Curry_Prelude.toCurryString "_inst#") Curry_Prelude.OP_List)) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_dpFunc l cd cs) (d_C_dpFunc r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_dpFunc z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_dpFunc e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "DefaultPolymorphic.dpFunc" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpFunc" (showCons x1))

d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick l cd cs)
    (d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpFunc._#selFP2#r'" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpFunc._#selFP2#r'" (showCons
    x1))

nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> IDSupply -> Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick l s cd cs)
    (nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpFunc._#selFP2#r'" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpFunc._#selFP2#r'" (showCons
    x1))

d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma l cd cs)
    (d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpFunc._#selFP3#sigma" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpFunc._#selFP3#sigma"
    (showCons x1))

nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> IDSupply -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma l s cd cs)
    (nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpFunc._#selFP3#sigma" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpFunc._#selFP3#sigma"
    (showCons x1))

d_C_dpRule :: FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_dpRule x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> Curry_State.d_C_liftS
    (acceptCs id (FlatCurry.Annotated.Curry_Types.C_ARule x2 x3))
    (Curry_Prelude.d_C_apply (d_C_dpExpr cd cs) x4 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> Curry_State.d_C_returnS
    x1
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (d_C_dpRule l cd cs) (d_C_dpRule r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> d_C_dpRule z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (d_C_dpRule e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "DefaultPolymorphic.dpRule" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpRule" (showCons x1))

nd_C_dpRule :: FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
nd_C_dpRule x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_State.nd_C_liftS (wrapDX id (acceptCs id
    (FlatCurry.Annotated.Curry_Types.C_ARule x2 x3))) (let s1 = leftSupply s2
                                                           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_dpExpr s0 cd cs) x4 s1
    cd cs)) s3 cd cs))
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> wrapDX id
    (Curry_State.d_C_returnS x1)
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (nd_C_dpRule l s cd cs) (nd_C_dpRule r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> nd_C_dpRule z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (nd_C_dpRule e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "DefaultPolymorphic.dpRule" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpRule" (showCons x1))

d_C_dpExpr :: Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_C_dpExpr cd cs = FlatCurry.Annotated.Curry_Goodies.d_C_trExpr (acceptCs id
  d_OP_dpExpr_dot_var_dot_17) (acceptCs id d_OP_dpExpr_dot_lit_dot_17) (acceptCs
  (acceptCs (acceptCs id)) d_OP_dpExpr_dot_cmb_dot_17) (acceptCs (acceptCs id)
  d_OP_dpExpr_dot_lat_dot_17) (acceptCs (acceptCs id)
  d_OP_dpExpr_dot_fre_dot_17) (acceptCs (acceptCs id)
  d_OP_dpExpr_dot_orr_dot_17) (acceptCs (acceptCs (acceptCs id))
  d_OP_dpExpr_dot_cse_dot_17) (acceptCs id d_OP_dpExpr_dot_bra_dot_17) (acceptCs
  (acceptCs id) d_OP_dpExpr_dot_typ_dot_17)

nd_C_dpExpr :: IDSupply -> Cover -> ConstStore -> Func
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)))
nd_C_dpExpr s cd cs = wrapNX id (FlatCurry.Annotated.Curry_Goodies.nd_C_trExpr
  (wrapDX (wrapNX id) (acceptCs id nd_OP_dpExpr_dot_var_dot_17)) (wrapDX (wrapNX
  id) (acceptCs id nd_OP_dpExpr_dot_lit_dot_17)) (wrapDX (wrapDX (wrapDX (wrapNX
  id))) (acceptCs (acceptCs (acceptCs id)) nd_OP_dpExpr_dot_cmb_dot_17)) (wrapDX
  (wrapDX (wrapNX id)) (acceptCs (acceptCs id) nd_OP_dpExpr_dot_lat_dot_17))
  (wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  nd_OP_dpExpr_dot_fre_dot_17)) (wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs
  id) nd_OP_dpExpr_dot_orr_dot_17)) (wrapDX (wrapDX (wrapDX (wrapNX id)))
  (acceptCs (acceptCs (acceptCs id)) nd_OP_dpExpr_dot_cse_dot_17)) (wrapDX
  (wrapNX id) (acceptCs id nd_OP_dpExpr_dot_bra_dot_17)) (wrapDX (wrapDX (wrapNX
  id)) (acceptCs (acceptCs id) nd_OP_dpExpr_dot_typ_dot_17)))

d_OP_dpExpr_dot_var_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_var_dot_17 x1 x2 cd cs = Curry_Prelude.d_OP_dollar (d_C_dflt x1)
  (FlatCurry.Annotated.Curry_Types.C_AVar x1 x2) cd cs

nd_OP_dpExpr_dot_var_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_var_dot_17 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_dflt x1))
  (FlatCurry.Annotated.Curry_Types.C_AVar x1 x2) s0 cd cs

d_OP_dpExpr_dot_lit_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_lit_dot_17 x1 x2 cd cs = Curry_Prelude.d_OP_dollar (d_C_dflt x1)
  (FlatCurry.Annotated.Curry_Types.C_ALit x1 x2) cd cs

nd_OP_dpExpr_dot_lit_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Literal -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_lit_dot_17 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_dflt x1))
  (FlatCurry.Annotated.Curry_Types.C_ALit x1 x2) s0 cd cs

d_OP_dpExpr_dot_cmb_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_cmb_dot_17 x1 x2 x3 x4 cd cs = Curry_State.d_C_bindS
  (Curry_State.d_C_liftS (acceptCs id (FlatCurry.Annotated.Curry_Types.C_AComb
  x1 x2 x3)) (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd cs) x4 cd
  cs) cd cs) (d_C_dflt x1)

nd_OP_dpExpr_dot_cmb_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_cmb_dot_17 x1 x2 x3 x4 s cd cs = let s4 = s
  in s4 `seq` wrapNX id (Curry_State.nd_C_bindS (let s3 = leftSupply s4
                                                     s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_State.nd_C_liftS (wrapDX id (acceptCs id
  (FlatCurry.Annotated.Curry_Types.C_AComb x1 x2 x3))) (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS s0
  cd cs) x4 s1 cd cs)) s3 cd cs)) (wrapNX id (nd_C_dflt x1)))

d_OP_dpExpr_dot_lat_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))) -> (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_lat_dot_17 x1 x2 x3 cd cs = let x4 = Curry_Prelude.d_C_unzip x2
                                                  cd cs
                                                x5 = d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs
                                                  x4 cd cs
                                                x6 = d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es
                                                  x4 cd cs
  in Curry_State.d_C_bindS (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS
  cd cs) x6 cd cs) (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 x1 x5 x3)

nd_OP_dpExpr_dot_lat_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_lat_dot_17 x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s0 = leftSupply s5
                   s6 = rightSupply s5
                   s1 = leftSupply s6
                   s4 = rightSupply s6
  in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x4 = Curry_Prelude.d_C_unzip x2
                                                   cd cs
                                                 x5 = nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs
                                                   x4 s0 cd cs
                                                 x6 = nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es
                                                   x4 s1 cd cs
  in wrapNX id (Curry_State.nd_C_bindS (let s3 = leftSupply s4
                                            s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS s2
  cd cs) x6 s3 cd cs)) (wrapNX id
  (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 x1 x5 x3))))))))

d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs l cd cs)
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpExpr.lat.17._#selFP5#vs" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpExpr.lat.17._#selFP5#vs"
    (showCons x1))

nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List (Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs l s cd cs)
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP5_hash_vs e s cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpExpr.lat.17._#selFP5#vs" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpExpr.lat.17._#selFP5#vs"
    (showCons x1))

d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es l cd cs)
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpExpr.lat.17._#selFP6#es" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpExpr.lat.17._#selFP6#es"
    (showCons x1))

nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List (Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)))
nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es l s cd cs)
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_selFP6_hash_es e s cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "DefaultPolymorphic.dpExpr.lat.17._#selFP6#es" [show x1] info)
  _ -> failCons cd (consFail "DefaultPolymorphic.dpExpr.lat.17._#selFP6#es"
    (showCons x1))

d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_bindS x3
  (d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1
  x4 x2)

nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1 x1 x2 x3 x4 s cd cs = wrapNX
  id (Curry_State.nd_C_bindS x3 (wrapNX id
  (nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2
  x1 x4 x2)))

d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_dollar (d_C_dflt x1)
  (FlatCurry.Annotated.Curry_Types.C_ALet x1 (Curry_Prelude.d_C_zip x3 x2 cd cs)
  x4) cd cs

nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_lat_dot_17_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 x4 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id (nd_C_dflt x1))
  (FlatCurry.Annotated.Curry_Types.C_ALet x1 (Curry_Prelude.d_C_zip x3 x2 cd cs)
  x4) s0 cd cs

d_OP_dpExpr_dot_fre_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_fre_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS x3
  (Curry_Prelude.d_OP_dot (d_C_dflt x1) (acceptCs id
  (FlatCurry.Annotated.Curry_Types.C_AFree x1 x2)) cd cs)

nd_OP_dpExpr_dot_fre_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_fre_dot_17 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_State.nd_C_bindS x3 (Curry_Prelude.nd_OP_dot
  (wrapNX id (nd_C_dflt x1)) (wrapDX id (acceptCs id
  (FlatCurry.Annotated.Curry_Types.C_AFree x1 x2))) s0 cd cs))

d_OP_dpExpr_dot_orr_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_orr_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS
  (Curry_State.d_C_liftS2 (acceptCs (acceptCs id)
  (FlatCurry.Annotated.Curry_Types.C_AOr x1)) x2 x3 cd cs) (d_C_dflt x1)

nd_OP_dpExpr_dot_orr_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_orr_dot_17 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_State.nd_C_bindS (Curry_State.nd_C_liftS2 (wrapDX
  (wrapDX id) (acceptCs (acceptCs id) (FlatCurry.Annotated.Curry_Types.C_AOr
  x1))) x2 x3 s0 cd cs) (wrapNX id (nd_C_dflt x1)))

d_OP_dpExpr_dot_cse_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> FlatCurry.Curry_Types.C_CaseType -> (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Curry_Prelude.OP_List (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1) -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_dpExpr_dot_cse_dot_17 x1 x2 x3 x4 cd cs = Curry_State.d_C_liftS2 (acceptCs
  (acceptCs id) (FlatCurry.Annotated.Curry_Types.C_ACase x1 x2)) x3
  (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd cs) x4 cd cs) cd cs

nd_OP_dpExpr_dot_cse_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> FlatCurry.Curry_Types.C_CaseType -> Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> Curry_Prelude.OP_List (Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1)) -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_dpExpr_dot_cse_dot_17 x1 x2 x3 x4 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_State.nd_C_liftS2 (wrapDX (wrapDX id) (acceptCs
  (acceptCs id) (FlatCurry.Annotated.Curry_Types.C_ACase x1 x2))) x3
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS s0
  cd cs) x4 s1 cd cs)) s3 cd cs))

d_OP_dpExpr_dot_bra_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1
d_OP_dpExpr_dot_bra_dot_17 x1 x2 cd cs = Curry_State.d_C_liftS (acceptCs id
  (FlatCurry.Annotated.Curry_Types.C_ABranch x1)) x2 cd cs

nd_OP_dpExpr_dot_bra_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> Func t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  t0) t1) -> IDSupply -> Cover -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1)
nd_OP_dpExpr_dot_bra_dot_17 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_State.nd_C_liftS (wrapDX id (acceptCs id
  (FlatCurry.Annotated.Curry_Types.C_ABranch x1))) x2 s0 cd cs

d_OP_dpExpr_dot_typ_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr
  -> (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dpExpr_dot_typ_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS
  (Curry_State.d_C_liftS (d_OP_dpExpr_dot_typ_dot_17_dot_uscore_hash_lambda3 x1
  x3) x2 cd cs) (d_C_dflt x1)

nd_OP_dpExpr_dot_typ_dot_17 :: FlatCurry.Curry_Types.C_TypeExpr -> Func
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) -> FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dpExpr_dot_typ_dot_17 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_State.nd_C_bindS (Curry_State.nd_C_liftS (wrapDX
  id (d_OP_dpExpr_dot_typ_dot_17_dot_uscore_hash_lambda3 x1 x3)) x2 s0 cd cs)
  (wrapNX id (nd_C_dflt x1)))

d_OP_dpExpr_dot_typ_dot_17_dot_uscore_hash_lambda3 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
d_OP_dpExpr_dot_typ_dot_17_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  FlatCurry.Annotated.Curry_Types.C_ATyped x1 x3 x2

d_C_dflt :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_dflt x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply (d_C_tyVars cd cs) x1 cd
                             cs
  in Curry_State.d_C_bindS Curry_State.d_C_getS
  (d_OP_dflt_dot_uscore_hash_lambda4 x1 x3 x2)

nd_C_dflt :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_C_dflt x1 x2 s cd cs = let s0 = s
  in s0 `seq` (let x3 = Curry_Prelude.nd_C_apply (wrapDX id (d_C_tyVars cd cs))
                     x1 s0 cd cs
  in wrapNX id (Curry_State.nd_C_bindS (wrapDX id Curry_State.d_C_getS) (wrapNX
  id (nd_OP_dflt_dot_uscore_hash_lambda4 x1 x3 x2))))

d_OP_dflt_dot_uscore_hash_lambda4 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_dflt_dot_uscore_hash_lambda4 x1 x2 x3 x4 cd cs =
  let x5 = Curry_Prelude.d_C_filter
        (d_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x4) x2 cd cs
  in d_C__case_0 x5 x1 x3 (Curry_Prelude.d_C_null x5 cd cs) cd cs

nd_OP_dflt_dot_uscore_hash_lambda4 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_dflt_dot_uscore_hash_lambda4 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x5 = Curry_Prelude.nd_C_filter (wrapNX id
                               (nd_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5
                               x4)) x2 s0 cd cs
  in nd_C__case_0 x5 x1 x3 (Curry_Prelude.d_C_null x5 cd cs) s1 cd cs)))

d_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 cd cs =
  Curry_Prelude.d_C_not (Curry_FiniteMap.d_C_elemFM
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs) x2 x1 cd cs) cd cs

nd_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 :: Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_dflt_dot_uscore_hash_lambda4_dot_uscore_hash_lambda5 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` Curry_Prelude.d_C_not (let s1 = leftSupply s2
                                         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_FiniteMap.nd_C_elemFM
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int s0
  cd cs) x2 x1 s1 cd cs)) cd cs

d_C_tyVars :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_C_tyVars cd cs = Curry_Prelude.d_OP_dot (Curry_List.d_C_nub
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs)) (FlatCurry.Annotated.Curry_Goodies.d_C_trTypeExpr (Curry_Prelude.d_C_flip
  (acceptCs (acceptCs id) Curry_Prelude.OP_Cons) Curry_Prelude.OP_List)
  d_OP_tyVars_dot_uscore_hash_lambda6 (acceptCs id Curry_Prelude.d_OP_plus_plus)
  (acceptCs id (Curry_Prelude.d_C_flip (acceptCs id
  (Curry_List.d_OP_backslash_backslash
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs)))))) cd cs

d_OP_tyVars_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_OP_tyVars_dot_uscore_hash_lambda6 x1 cd cs = Curry_Prelude.d_C_concat

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_0 x5 x1 x3 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_State.d_C_returnS x3
  Curry_Prelude.C_False -> let x6 = Curry_Prelude.d_OP_dollar
                                 (Curry_FiniteMap.d_C_listToFM
                                 (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
                                 cd cs)
                                 (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
                                 cd cs) cd cs) (Curry_Prelude.d_C_zip x5
                                 (Curry_Prelude.d_C_repeat (d_C_defaultType cd
                                 cs) cd cs) cd cs) cd cs
    in Curry_State.d_C_bindS_ (Curry_State.d_C_modifyS
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
    cs) x6)) (Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_ATyped
    x1 x3 x1)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x1 x3 l cd
    cs) (d_C__case_0 x5 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x5 x1 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "DefaultPolymorphic._case_0" [show x5, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "DefaultPolymorphic._case_0" (showCons x7))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
nd_C__case_0 x5 x1 x3 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> wrapDX id (Curry_State.d_C_returnS x3)
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s4 = leftSupply s8
                     s7 = rightSupply s8
    in s4 `seq` (s7 `seq` (let x6 = let s3 = leftSupply s4
                                        s2 = rightSupply s4
                                 in s3 `seq` (s2 `seq`
                                 Curry_Prelude.nd_OP_dollar (let s1 = leftSupply
                                                                   s2
                                                                 s0 = rightSupply
                                                                   s2
                                 in s1 `seq` (s0 `seq`
                                 Curry_FiniteMap.nd_C_listToFM
                                 (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
                                 s0 cd cs) (wrapDX (wrapDX id)
                                 (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
                                 cd cs)) s1 cd cs)) (Curry_Prelude.d_C_zip x5
                                 (Curry_Prelude.d_C_repeat (d_C_defaultType cd
                                 cs) cd cs) cd cs) s3 cd cs)
    in let s6 = leftSupply s7
           s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_State.nd_C_bindS_ (wrapNX id
    (Curry_State.nd_C_modifyS (wrapNX id (Curry_FiniteMap.nd_C_plusFM
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int s5
    cd cs) x6)))) (wrapDX id (Curry_State.d_C_returnS
    (FlatCurry.Annotated.Curry_Types.C_ATyped x1 x3 x1))) s6 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x5 x1 x3 l s
    cd cs) (nd_C__case_0 x5 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x5
    x1 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x5 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "DefaultPolymorphic._case_0" [show x5, show x1, show x3, show x7] info)
  _ -> failCons cd (consFail "DefaultPolymorphic._case_0" (showCons x7))

d_C__case_2 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_Visibility
  -> Curry_Prelude.C_Int -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr
d_C__case_2 x2 x6 x5 x4 x3 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> d_C__case_1 x6 x5 x4 x3 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x6 x5 x4 x3
    x1 l cd cs) (d_C__case_2 x2 x6 x5 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x6
    x5 x4 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x2 x6 x5 x4 x3
    x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "DefaultPolymorphic._case_2" [show x2, show x6, show x5, show x4, show x3
    , show x1, show x7] info)
  _ -> failCons cd (consFail "DefaultPolymorphic._case_2" (showCons x7))

d_C__case_1 :: FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr
d_C__case_1 x6 x5 x4 x3 x2 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> let x7 = Curry_Prelude.d_C_apply (d_C_tyVars cd cs) x5
                                cd cs
                              x8 = Curry_State.d_C_runState (d_C_dpRule x6 cd
                                cs) (Curry_Prelude.d_C_apply
                                (Curry_FiniteMap.d_C_listToFM
                                (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
                                cd cs)
                                (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
                                cd cs) cd cs) (Curry_Prelude.d_C_zip x7
                                (Curry_Prelude.d_C_map (acceptCs id
                                FlatCurry.Curry_Types.C_TVar) x7 cd cs) cd cs)
                                cd cs) cd cs
                              x9 = d_OP_dpFunc_dot_uscore_hash_selFP2_hash_r_tick
                                x8 cd cs
                              x10 = d_OP_dpFunc_dot_uscore_hash_selFP3_hash_sigma
                                x8 cd cs
    in FlatCurry.Annotated.Curry_TypeSubst.d_C_substFunc x10
    (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x9) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x6 x5 x4 x3 x2
    l cd cs) (d_C__case_1 x6 x5 x4 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x5
    x4 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x6 x5 x4 x3 x2
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "DefaultPolymorphic._case_1" [show x6, show x5, show x4, show x3, show x2
    , show x11] info)
  _ -> failCons cd (consFail "DefaultPolymorphic._case_1" (showCons x11))

