{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_Compile
  ( d_C_main
  , d_C_build
  , d_C_locateCurryFile
  , d_C_makeModule
  , nd_C_makeModule
  , d_C_writeAnalysis
  , nd_C_writeAnalysis
  , d_C_readAnalysis
  , nd_C_readAnalysis
  , d_C_loadAnalysis
  , nd_C_loadAnalysis
  , d_C_compileModule
  , nd_C_compileModule
  , d_C_extractFuncInfos
  , d_C_patchPreludeExports
  , d_C_compMessage
  , d_C_filterPrelude
  , d_C_integrateExternals
  , d_C_lookupExternals
  , d_C_splitExternals
  , d_C_dump
  , d_C_rename
  , d_C_defaultModules
  , d_C_fst3 )
  where

import Basics
import qualified Curry_AbstractHaskell
import qualified Curry_AbstractHaskellGoodies
import qualified Curry_AbstractHaskellPrinter
import qualified Curry_Analysis
import qualified Curry_Char
import qualified Curry_Classification
import qualified Curry_CompilerOpts
import qualified Curry_DefaultPolymorphic
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_EliminateCond
import qualified Curry_FilePath
import qualified Curry_Files
import qualified Curry_FiniteMap
import qualified FlatCurry.Annotated.Curry_Files
import qualified FlatCurry.Annotated.Curry_Goodies
import qualified FlatCurry.Annotated.Curry_Types
import qualified FlatCurry.Curry_Goodies
import qualified FlatCurry.Curry_Types
import qualified Curry_IOExts
import qualified Curry_LiftCase
import qualified Curry_List
import qualified Curry_Maybe
import qualified Curry_Message
import qualified Curry_MissingImports
import qualified Curry_ModuleDeps
import qualified Curry_Names
import qualified Curry_Prelude
import qualified Curry_RCFile
import qualified Curry_ReadShowTerm
import qualified Curry_SimpleMake
import qualified Curry_System
import qualified Curry_TransFunctions
import qualified Curry_TransTypes
import qualified Curry_Utils


d_C_main :: Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_main cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_RCFile.d_C_readRC cd cs) d_OP_main_dot_uscore_hash_lambda4 cd cs

d_OP_main_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda4 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_System.d_C_getArgs cd cs)
  (d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 x2) cd cs

d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_CompilerOpts.d_C_getCompilerOpts cd cs)
  (d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
  x3 x1) cd cs

d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2
  Curry_CompilerOpts.C_Options (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_mapIO_ (d_C_build (d_C__case_32 x1 x2 x4 cd cs)) cd cs)
    x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 l cd cs)
    (d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_main_dot_uscore_hash_lambda4_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8
    x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.main._#lambda4._#lambda6._#lambda8" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "Compile.main._#lambda4._#lambda6._#lambda8"
    (showCons x3))

d_C_build :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_build x1 x2 cd cs = let x3 = d_C__case_31 x1
                              (Curry_TransFunctions.d_C_defaultState cd cs) cd
                              cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_locateCurryFile x2 cd cs) (d_OP_build_dot_uscore_hash_lambda34 x1 x3 x2)
  cd cs

d_OP_build_dot_uscore_hash_lambda34 :: Curry_CompilerOpts.C_Options
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar
    Curry_Message.d_C_putErrLn (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not find module ") x3 cd cs) cd cs
  Curry_Prelude.C_Just x5 -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_ModuleDeps.d_C_deps x1 x3 x5 cd cs)
    (d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x2) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 l cd cs)
    (d_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Compile.build._#lambda34" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.build._#lambda34" (showCons x4))

nd_OP_build_dot_uscore_hash_lambda34 :: Curry_CompilerOpts.C_Options
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Message.d_C_putErrLn) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Could not find module ") x3 cd cs) s0 cd cs
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_ModuleDeps.d_C_deps x1 x3 x5 cd cs) (wrapNX id
    (nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x2)) s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 l s cd cs)
    (nd_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_build_dot_uscore_hash_lambda34 x1 x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Compile.build._#lambda34" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.build._#lambda34" (showCons x4))

d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_30 x4 x3 x1 (Curry_Prelude.d_C_null
    x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 l cd cs)
    (d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.build._#lambda34._#lambda38" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.build._#lambda34._#lambda38" (showCons
    x2))

nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_30 x4 x3 x1 (Curry_Prelude.d_C_null x4 cd cs) s0 cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 l s cd cs)
    (nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_build_dot_uscore_hash_lambda34_dot_uscore_hash_lambda38 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.build._#lambda34._#lambda38" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.build._#lambda34._#lambda38" (showCons
    x2))

d_C_locateCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_locateCurryFile x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Directory.d_C_doesFileExist x1 cd cs)
  (d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1) cd cs

d_OP_locateCurryFile_dot_uscore_hash_lambda41 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.C_Just x1) cd cs
  Curry_Prelude.C_False -> let x3 = Curry_Distribution.d_C_stripCurrySuffix x1
                                 cd cs
                               x4 = FlatCurry.Annotated.Curry_Files.d_C_typedFlatCurryFileName
                                 x3 cd cs
    in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Distribution.d_C_lookupModuleSourceInLoadPath x3 cd cs)
    (Curry_Prelude.d_C_maybe
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Distribution.d_C_getLoadPathForModule x3 cd cs)
    (Curry_Files.d_C_lookupFileInPath x4 (Curry_Prelude.OP_Cons
    Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1 l cd cs)
    (d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_locateCurryFile_dot_uscore_hash_lambda41 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Compile.locateCurryFile._#lambda41" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.locateCurryFile._#lambda41" (showCons x2))

d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.C_Just x3) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43 l cd
    cs) (d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_locateCurryFile_dot_uscore_hash_lambda41_dot_uscore_hash_lambda43 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.locateCurryFile._#lambda41._#lambda43" [show x1] info)
  _ -> failCons cd (consFail "Compile.locateCurryFile._#lambda41._#lambda43"
    (showCons x1))

d_C_makeModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C_makeModule x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_29 x1 x2 x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_makeModule x1 x2 l
    cd cs) (d_C_makeModule x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_makeModule
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_makeModule x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.makeModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.makeModule" (showCons x3))

nd_C_makeModule :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C_makeModule x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_29 x1 x2 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_makeModule x1 x2 l
    s cd cs) (nd_C_makeModule x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_makeModule x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_makeModule x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.makeModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.makeModule" (showCons x3))

d_OP_makeModule_dot_uscore_hash_lambda45 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_makeModule_dot_uscore_hash_lambda45 x1 x2 x3 x4 x5 x6 cd cs = let x7 = x6
                                                                       x8 = Curry_Prelude.OP_Cons
                                                                         x3
                                                                         (d_C__case_25
                                                                         x2 x7
                                                                         cd cs)
                                                                       x9 = Curry_Prelude.d_C_map
                                                                         (d_OP_makeModule_dot_uscore_hash_lambda45_dot_uscore_hash_lambda47
                                                                         x1 x5)
                                                                         x4 cd
                                                                         cs
  in Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_plus_plus x8 x9 cd cs) cd cs

d_OP_makeModule_dot_uscore_hash_lambda45_dot_uscore_hash_lambda47 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_makeModule_dot_uscore_hash_lambda45_dot_uscore_hash_lambda47 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_dollar (Curry_Names.d_C_destFile
  (Curry_CompilerOpts.d_C_optTraceFailure x1 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x3)
  (Curry_Prelude.d_OP_dollar d_C_fst3 (Curry_Prelude.d_OP_dollar
  Curry_Maybe.d_C_fromJust (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) cd cs) x3 x2 cd cs) cd cs) cd cs) cd cs

d_OP_makeModule_dot_uscore_hash_lambda49 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_makeModule_dot_uscore_hash_lambda49 x1 x2 x3 x4 x5 x6 x7 cd cs =
  let x8 = x7
  in Curry_SimpleMake.d_C_smake (Curry_Names.d_C_destFile
  (Curry_CompilerOpts.d_C_optTraceFailure x1 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x5 x4 cd cs) x8
  (d_C_compileModule x2 x3 x6 cd cs) (d_C_loadAnalysis x2 x3 x6 cd cs) cd cs

nd_OP_makeModule_dot_uscore_hash_lambda49 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_OP_makeModule_dot_uscore_hash_lambda49 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  let s3 = s
  in s3 `seq` (let x8 = x7
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_SimpleMake.nd_C_smake
  (Curry_Names.d_C_destFile (Curry_CompilerOpts.d_C_optTraceFailure x1 cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x5 x4 cd cs) x8
  (nd_C_compileModule x2 x3 x6 s0 cd cs) (nd_C_loadAnalysis x2 x3 x6 s1 cd cs)
  s2 cd cs))))

d_C_writeAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_writeAnalysis x1 x2 x3 x4 cd cs = let x5 = Curry_Names.d_C_analysisFile
                                            (Curry_CompilerOpts.d_C_optOutputSubdir
                                            x1 cd cs) x2 x3 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x1)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing Analysis file ") x5 cd cs) cd cs)
  (Curry_Files.d_C_writeQTermFileInDir x5 (Curry_Analysis.d_C_showAnalysisResult
  x4 cd cs) cd cs) cd cs

nd_C_writeAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C_writeAnalysis x1 x2 x3 x4 s cd cs = let s3 = s
  in s3 `seq` (let x5 = Curry_Names.d_C_analysisFile
                     (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x2 x3 cd
                     cs
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing Analysis file ") x5 cd cs) s0 cd cs)
  (Curry_Files.d_C_writeQTermFileInDir x5
  (Curry_Analysis.nd_C_showAnalysisResult x4 s1 cd cs) cd cs) s2 cd cs))))

d_C_readAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))
d_C_readAnalysis x1 x2 x3 cd cs = let x4 = Curry_Names.d_C_analysisFile
                                        (Curry_CompilerOpts.d_C_optOutputSubdir
                                        x1 cd cs) x2 x3 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x1)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Reading Analysis file ") x4 cd cs) cd cs) (Curry_Prelude.d_C_liftIO
  Curry_Analysis.d_C_readAnalysisResult (Curry_ReadShowTerm.d_C_readQTermFile x4
  cd cs) cd cs) cd cs

nd_C_readAnalysis :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))
nd_C_readAnalysis x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let x4 = Curry_Names.d_C_analysisFile
                     (Curry_CompilerOpts.d_C_optOutputSubdir x1 cd cs) x2 x3 cd
                     cs
  in let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Reading Analysis file ") x4 cd cs) s0 cd cs) (Curry_Prelude.nd_C_liftIO
  (wrapNX id Curry_Analysis.nd_C_readAnalysisResult)
  (Curry_ReadShowTerm.d_C_readQTermFile x4 cd cs) s1 cd cs) s2 cd cs))))

d_C_loadAnalysis :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C_loadAnalysis x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_24 x2 x1 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_loadAnalysis x1 x2 l
    cd cs) (d_C_loadAnalysis x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_loadAnalysis x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_loadAnalysis x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.loadAnalysis" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis" (showCons x3))

nd_C_loadAnalysis :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C_loadAnalysis x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_24 x2 x1 x5 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_loadAnalysis x1 x2
    l s cd cs) (nd_C_loadAnalysis x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_loadAnalysis x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_loadAnalysis x1 x2
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.loadAnalysis" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis" (showCons x3))

d_OP_loadAnalysis_dot_uscore_hash_lambda52 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple5 x3 x4 x5 x6 x7 -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C__case_22 x7 x6 x5 x4 x3 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple5 d i l r -> narrow d i
    (d_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 l cd cs)
    (d_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple5 d i xs -> narrows cs d i (\z ->
    d_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple5 d c e -> guardCons d c
    (d_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple5 d info -> failCons d (traceFail
    "Compile.loadAnalysis._#lambda52" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis._#lambda52" (showCons x2))

nd_OP_loadAnalysis_dot_uscore_hash_lambda52 :: Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple5 x3 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq`
    Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (nd_C__case_22 x7 x6 x5 x4 x3 x1 s0 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple5 d i l r -> narrow d i
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 l s cd cs)
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple5 d i xs -> narrows cs d i (\z ->
    nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple5 d c e -> guardCons d c
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple5 d info -> failCons d (traceFail
    "Compile.loadAnalysis._#lambda52" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.loadAnalysis._#lambda52" (showCons x2))

d_C_compileModule :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_C_compileModule x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_21 x2 x1 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_compileModule x1 x2
    l cd cs) (d_C_compileModule x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_compileModule x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_compileModule x1 x2
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.compileModule" (showCons x3))

nd_C_compileModule :: Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C_compileModule x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_21 x2 x1 x5 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_compileModule x1 x2
    l s cd cs) (nd_C_compileModule x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_compileModule x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_compileModule x1 x2
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.compileModule" (showCons x3))

d_OP_compileModule_dot_tfcyFile_dot_53 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_compileModule_dot_tfcyFile_dot_53 x1 cd cs = Curry_Files.d_C_withExtension
  (Curry_Prelude.d_C_const (Curry_Prelude.toCurryString ".tfcy")) x1 cd cs

d_OP_compileModule_dot_fcyFile_dot_53 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_compileModule_dot_fcyFile_dot_53 x1 cd cs = Curry_Files.d_C_withExtension
  (Curry_Prelude.d_C_const (Curry_Prelude.toCurryString ".fcy")) x1 cd cs

d_OP_compileModule_dot_ahsFile_dot_53 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_compileModule_dot_ahsFile_dot_53 x1 cd cs = Curry_Files.d_C_withExtension
  (Curry_Prelude.d_C_const (Curry_Prelude.toCurryString ".ahs")) x1 cd cs

d_OP_compileModule_dot_uscore_hash_lambda66 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda66 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 cd cs =
  let x19 = x18
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showStatus x1) (d_C_compMessage
  (Curry_Prelude.OP_Tuple2 x2 x3) (Curry_Prelude.toCurryString "Compiling") x14
  (Curry_Prelude.OP_Tuple2 x10 x7) cd cs) cd cs) (let x20 = d_C_filterPrelude x1
                                                        (Curry_Prelude.d_C_read
                                                        (FlatCurry.Annotated.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
                                                        (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_Types_dot_TypeExpr
                                                        cd cs) cd cs) x19 cd cs)
                                                        cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTypedFlat x1 x17 (Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) x20 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Lifting case expressions") cd cs) (let x21 = Curry_LiftCase.d_C_liftCases
                                            Curry_Prelude.C_True x20 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpLifted x1 x13 (Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) x21 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Eliminate calls to cond") cd cs)
  (let x22 = Curry_EliminateCond.d_C_eliminateCond x21 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpEliminated x1 x8 (Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) x22 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Default locally polymorphic sub-expressions") cd cs)
  (let x23 = Curry_Prelude.d_C_apply
         (Curry_DefaultPolymorphic.d_C_defaultPolymorphic cd cs) x22 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpDefaulted x1 x6 (Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) x23 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Extending imports") cd cs)
  (let x24 = Curry_MissingImports.d_C_fixMissingImports x23 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpExtImports x1 x9 (Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) x24 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Renaming symbols") cd cs) (let x25 = d_C_rename (Curry_Prelude.d_C_apply
                                    (FlatCurry.Annotated.Curry_Goodies.d_C_unAnnProg
                                    cd cs) x24 cd cs) cd cs
                                  x26 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
                                    x25 cd cs
                                  x27 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
                                    x25 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpRenamed x1 x15 (Curry_Prelude.d_C_apply
  (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Prog
  cd cs) x26 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Transforming functions") cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_C_apply (Curry_TransFunctions.d_C_runIOES
  (Curry_TransFunctions.d_C_trProg x26 cd cs) cd cs) x4 cd cs)
  (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 x1 x27
  x5 x7 x10 x11 x12 x14 x16) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd
  cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_compileModule_dot_uscore_hash_lambda66 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda66 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 s cd cs =
  let s75 = s
  in s75 `seq` (let x19 = x18
  in let s74 = leftSupply s75
         s76 = rightSupply s75
         s0 = leftSupply s76
         s73 = rightSupply s76
  in s74 `seq` (s76 `seq` (s0 `seq` (s73 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showStatus x1))
  (d_C_compMessage (Curry_Prelude.OP_Tuple2 x2 x3) (Curry_Prelude.toCurryString
  "Compiling") x14 (Curry_Prelude.OP_Tuple2 x10 x7) cd cs) s0 cd cs)
  (let s5 = leftSupply s73
       s71 = rightSupply s73
  in s5 `seq` (s71 `seq` (let x20 = d_C_filterPrelude x1 (let s4 = leftSupply s5
                                                              s3 = rightSupply
                                                                s5
                                in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_read
                                (let s2 = leftSupply s3
                                     s1 = rightSupply s3
                                in s2 `seq` (s1 `seq`
                                FlatCurry.Annotated.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
                                (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_FlatCurry_dot_Types_dot_TypeExpr
                                s1 cd cs) s2 cd cs)) x19 s4 cd cs)) cd cs
  in let s70 = leftSupply s71
         s72 = rightSupply s71
         s10 = leftSupply s72
         s69 = rightSupply s72
  in s70 `seq` (s72 `seq` (s10 `seq` (s69 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTypedFlat x1 x17 (let s9 = leftSupply s10
                                                           s8 = rightSupply s10
  in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (let s7 = leftSupply s8
                                                      s6 = rightSupply s8
  in s7 `seq` (s6 `seq`
  FlatCurry.Annotated.Curry_Types.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  s6 cd cs) s7 cd cs)) x20 s9 cd cs)) cd cs) (let s68 = leftSupply s69
                                                  s66 = rightSupply s69
  in s68 `seq` (s66 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Lifting case expressions") cd cs) (let x21 = Curry_LiftCase.d_C_liftCases
                                            Curry_Prelude.C_True x20 cd cs
  in let s65 = leftSupply s66
         s67 = rightSupply s66
         s15 = leftSupply s67
         s64 = rightSupply s67
  in s65 `seq` (s67 `seq` (s15 `seq` (s64 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpLifted x1 x13 (let s14 = leftSupply s15
                                                        s13 = rightSupply s15
  in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (let s12 = leftSupply s13
                                                        s11 = rightSupply s13
  in s12 `seq` (s11 `seq`
  FlatCurry.Annotated.Curry_Types.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  s11 cd cs) s12 cd cs)) x21 s14 cd cs)) cd cs) (let s63 = leftSupply s64
                                                     s61 = rightSupply s64
  in s63 `seq` (s61 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Eliminate calls to cond") cd cs)
  (let x22 = Curry_EliminateCond.d_C_eliminateCond x21 cd cs
  in let s60 = leftSupply s61
         s62 = rightSupply s61
         s20 = leftSupply s62
         s59 = rightSupply s62
  in s60 `seq` (s62 `seq` (s20 `seq` (s59 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpEliminated x1 x8 (let s19 = leftSupply s20
                                                           s18 = rightSupply s20
  in s19 `seq` (s18 `seq` Curry_Prelude.nd_C_apply (let s17 = leftSupply s18
                                                        s16 = rightSupply s18
  in s17 `seq` (s16 `seq`
  FlatCurry.Annotated.Curry_Types.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  s16 cd cs) s17 cd cs)) x22 s19 cd cs)) cd cs) (let s58 = leftSupply s59
                                                     s57 = rightSupply s59
  in s58 `seq` (s57 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Default locally polymorphic sub-expressions") cd cs) (let s21 = leftSupply
                                                               s57
                                                             s55 = rightSupply
                                                               s57
  in s21 `seq` (s55 `seq` (let x23 = Curry_Prelude.nd_C_apply (wrapDX id
                                 (Curry_DefaultPolymorphic.d_C_defaultPolymorphic
                                 cd cs)) x22 s21 cd cs
  in let s54 = leftSupply s55
         s56 = rightSupply s55
         s26 = leftSupply s56
         s53 = rightSupply s56
  in s54 `seq` (s56 `seq` (s26 `seq` (s53 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpDefaulted x1 x6 (let s25 = leftSupply s26
                                                          s24 = rightSupply s26
  in s25 `seq` (s24 `seq` Curry_Prelude.nd_C_apply (let s23 = leftSupply s24
                                                        s22 = rightSupply s24
  in s23 `seq` (s22 `seq`
  FlatCurry.Annotated.Curry_Types.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  s22 cd cs) s23 cd cs)) x23 s25 cd cs)) cd cs) (let s52 = leftSupply s53
                                                     s50 = rightSupply s53
  in s52 `seq` (s50 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Extending imports") cd cs)
  (let x24 = Curry_MissingImports.d_C_fixMissingImports x23 cd cs
  in let s49 = leftSupply s50
         s51 = rightSupply s50
         s31 = leftSupply s51
         s48 = rightSupply s51
  in s49 `seq` (s51 `seq` (s31 `seq` (s48 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpExtImports x1 x9 (let s30 = leftSupply s31
                                                           s29 = rightSupply s31
  in s30 `seq` (s29 `seq` Curry_Prelude.nd_C_apply (let s28 = leftSupply s29
                                                        s27 = rightSupply s29
  in s28 `seq` (s27 `seq`
  FlatCurry.Annotated.Curry_Types.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Annotated_dot_Types_dot_AProg
  (FlatCurry.Curry_Types.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_TypeExpr
  s27 cd cs) s28 cd cs)) x24 s30 cd cs)) cd cs) (let s47 = leftSupply s48
                                                     s46 = rightSupply s48
  in s47 `seq` (s46 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Renaming symbols") cd cs) (let s32 = leftSupply s46
                                  s44 = rightSupply s46
  in s32 `seq` (s44 `seq` (let x25 = d_C_rename (Curry_Prelude.nd_C_apply
                                 (wrapDX id
                                 (FlatCurry.Annotated.Curry_Goodies.d_C_unAnnProg
                                 cd cs)) x24 s32 cd cs) cd cs
                               x26 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
                                 x25 cd cs
                               x27 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
                                 x25 cd cs
  in let s43 = leftSupply s44
         s45 = rightSupply s44
         s33 = leftSupply s45
         s42 = rightSupply s45
  in s43 `seq` (s45 `seq` (s33 `seq` (s42 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpRenamed x1 x15 (Curry_Prelude.nd_C_apply
  (wrapDX id
  (FlatCurry.Curry_Types.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_FlatCurry_dot_Types_dot_Prog
  cd cs)) x26 s33 cd cs) cd cs) (let s41 = leftSupply s42
                                     s40 = rightSupply s42
  in s41 `seq` (s40 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Transforming functions") cd cs) (let s39 = leftSupply s40
                                        s38 = rightSupply s40
  in s39 `seq` (s38 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (let s37 = leftSupply s38
       s36 = rightSupply s38
  in s37 `seq` (s36 `seq` Curry_Prelude.nd_C_apply (let s35 = leftSupply s36
                                                        s34 = rightSupply s36
  in s35 `seq` (s34 `seq` Curry_TransFunctions.nd_C_runIOES
  (Curry_TransFunctions.nd_C_trProg x26 s34 cd cs) s35 cd cs)) x4 s37 cd cs))
  (wrapNX id
  (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 x1 x27
  x5 x7 x10 x11 x12 x14 x16)) s39 cd cs)) s41 cd cs)) s43 cd cs)))))) s47 cd
  cs)) s49 cd cs)))) s52 cd cs)) s54 cd cs)))))) s58 cd cs)) s60 cd cs)))) s63
  cd cs)) s65 cd cs)))) s68 cd cs)) s70 cd cs)))))) s74 cd cs))))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> FlatCurry.Curry_Types.C_Prog
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed x1 cd cs =
  case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> x1
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
    r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
    z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP10_hash_renamed
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#selFP10#renamed" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#selFP10#renamed" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts x1 cd cs =
  case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> x4
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
    r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
    z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_selFP11_hash_ts
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#selFP11#ts" [show x1] info)
  _ -> failCons cd (consFail "Compile.compileModule._#lambda66._#selFP11#ts"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 cd cs =
  let x11 = x10
      x12 = Curry_Prelude.d_C_either Curry_Prelude.d_C_error
        Curry_Prelude.d_C_id x11 cd cs
      x13 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
        x12 cd cs
      x14 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
        x12 cd cs
      x15 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
        x12 cd cs
      x16 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
        x12 cd cs
      x17 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
        x12 cd cs
      x18 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
        x12 cd cs
      x19 = d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
        x12 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_writeAnalysis (Curry_TransFunctions.d_C_compOptions x19 cd cs) x8 x5 x18
  cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpFunDecls x1 x6 (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskell.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_Prog
  cd cs) x13 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Transforming type declarations") cd cs) (let x20 = Curry_Prelude.d_C_apply
                                                  (Curry_TransTypes.d_C_transTypes
                                                  (Curry_TransFunctions.d_C_hoResultCons
                                                  x19 cd cs) cd cs) x2 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTypeDecls x1 x9 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket
  (Curry_AbstractHaskell.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_TypeDecl
  cd cs) cd cs) x20 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Combining to Abstract Haskell") cd cs)
  (let x21 = Curry_AbstractHaskell.C_Prog x14 (Curry_Prelude.d_OP_plus_plus
         (d_C_defaultModules cd cs) x15 cd cs) x20 x16 x17
       x22 = d_C_patchPreludeExports x21 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTranslated x1 x3 (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskell.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_Prog
  cd cs) x22 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Integrating external declarations") cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_integrateExternals x1 x22 x5 cd cs)
  (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70
  x1 x19 x16 x4 x7) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 s cd cs =
  let s43 = s
  in s43 `seq` (let s44 = leftSupply s43
                    s47 = rightSupply s43
                    s45 = leftSupply s44
                    s46 = rightSupply s44
                    s0 = leftSupply s45
                    s1 = rightSupply s45
                    s2 = leftSupply s46
                    s3 = rightSupply s46
                    s48 = leftSupply s47
                    s49 = rightSupply s47
                    s4 = leftSupply s48
                    s5 = rightSupply s48
                    s6 = leftSupply s49
                    s50 = rightSupply s49
                    s7 = leftSupply s50
                    s41 = rightSupply s50
  in s44 `seq` (s47 `seq` (s45 `seq` (s46 `seq` (s0 `seq` (s1 `seq` (s2 `seq`
  (s3 `seq` (s48 `seq` (s49 `seq` (s4 `seq` (s5 `seq` (s6 `seq` (s50 `seq`
  (s7 `seq` (s41 `seq` (let x11 = x10
                            x12 = Curry_Prelude.nd_C_either (wrapDX id
                              Curry_Prelude.d_C_error) (wrapDX id
                              Curry_Prelude.d_C_id) x11 s0 cd cs
                            x13 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
                              x12 s1 cd cs
                            x14 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
                              x12 s2 cd cs
                            x15 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
                              x12 s3 cd cs
                            x16 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
                              x12 s4 cd cs
                            x17 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
                              x12 s5 cd cs
                            x18 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
                              x12 s6 cd cs
                            x19 = nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
                              x12 s7 cd cs
  in let s40 = leftSupply s41
         s42 = rightSupply s41
         s10 = leftSupply s42
         s38 = rightSupply s42
  in s40 `seq` (s42 `seq` (s10 `seq` (s38 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (let s9 = leftSupply s10
       s8 = rightSupply s10
  in s9 `seq` (s8 `seq` nd_C_writeAnalysis
  (Curry_TransFunctions.nd_C_compOptions x19 s8 cd cs) x8 x5 x18 s9 cd cs))
  (let s37 = leftSupply s38
       s39 = rightSupply s38
       s11 = leftSupply s39
       s36 = rightSupply s39
  in s37 `seq` (s39 `seq` (s11 `seq` (s36 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpFunDecls x1 x6 (Curry_Prelude.nd_C_apply
  (wrapDX id
  (Curry_AbstractHaskell.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_Prog
  cd cs)) x13 s11 cd cs) cd cs) (let s35 = leftSupply s36
                                     s34 = rightSupply s36
  in s35 `seq` (s34 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Transforming type declarations") cd cs) (let s16 = leftSupply s34
                                                s32 = rightSupply s34
  in s16 `seq` (s32 `seq` (let x20 = let s15 = leftSupply s16
                                         s14 = rightSupply s16
                                 in s15 `seq` (s14 `seq`
                                 Curry_Prelude.nd_C_apply (let s13 = leftSupply
                                                                 s14
                                                               s12 = rightSupply
                                                                 s14
                                 in s13 `seq` (s12 `seq`
                                 Curry_TransTypes.nd_C_transTypes
                                 (Curry_TransFunctions.nd_C_hoResultCons x19 s12
                                 cd cs) s13 cd cs)) x2 s15 cd cs)
  in let s31 = leftSupply s32
         s33 = rightSupply s32
         s21 = leftSupply s33
         s30 = rightSupply s33
  in s31 `seq` (s33 `seq` (s21 `seq` (s30 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTypeDecls x1 x9 (let s20 = leftSupply s21
                                                          s19 = rightSupply s21
  in s20 `seq` (s19 `seq` Curry_Prelude.nd_C_apply (let s18 = leftSupply s19
                                                        s17 = rightSupply s19
  in s18 `seq` (s17 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_lbracket_rbracket
  (Curry_AbstractHaskell.nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_TypeDecl
  s17 cd cs) s18 cd cs)) x20 s20 cd cs)) cd cs) (let s29 = leftSupply s30
                                                     s27 = rightSupply s30
  in s29 `seq` (s27 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Combining to Abstract Haskell") cd cs)
  (let x21 = Curry_AbstractHaskell.C_Prog x14 (Curry_Prelude.d_OP_plus_plus
         (d_C_defaultModules cd cs) x15 cd cs) x20 x16 x17
       x22 = d_C_patchPreludeExports x21 cd cs
  in let s26 = leftSupply s27
         s28 = rightSupply s27
         s22 = leftSupply s28
         s25 = rightSupply s28
  in s26 `seq` (s28 `seq` (s22 `seq` (s25 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_dump Curry_CompilerOpts.C_DumpTranslated x1 x3 (Curry_Prelude.nd_C_apply
  (wrapDX id
  (Curry_AbstractHaskell.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_AbstractHaskell_dot_Prog
  cd cs)) x22 s22 cd cs) cd cs) (let s24 = leftSupply s25
                                     s23 = rightSupply s25
  in s24 `seq` (s23 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
  "Integrating external declarations") cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_integrateExternals x1 x22 x5 cd cs) (wrapNX id
  (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70
  x1 x19 x16 x4 x7)) s23 cd cs) s24 cd cs)) s26 cd cs)))) s29 cd cs)) s31 cd
  cs)))))) s35 cd cs)) s37 cd cs)))) s40 cd cs))))))))))))))))))))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_19 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP3#ahsFun" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP3#ahsFun" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Prog
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_19 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP3_hash_ahsFun
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP3#ahsFun" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP3#ahsFun" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_17 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP4#n" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP4#n" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_17 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP4_hash_n
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP4#n" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP4#n" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_15 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP5#imps" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP5#imps" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_15 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP5_hash_imps
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP5#imps" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP5#imps" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_13 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP6#funs" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP6#funs" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_13 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP6_hash_funs
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP6#funs" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP6#funs" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_11 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP7#ops" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP7#ops" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_11 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP7_hash_ops
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP7#ops" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP7#ops" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_9 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP8#modAnalysisResult"
    [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP8#modAnalysisResult"
    (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_9 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP8_hash_modAnalysisResult
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP8#modAnalysisResult"
    [show x1] info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP8#modAnalysisResult"
    (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> Cover
  -> ConstStore -> Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_7 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    l cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP9#state'" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP9#state'" (showCons x1))

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass))) Curry_TransFunctions.C_State -> IDSupply
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_7 x3 x2 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    l s cd cs)
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_selFP9_hash_state_tick
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP9#state'" [show x1]
    info)
  _ -> failCons cd (consFail
    "Compile.compileModule._#lambda66._#lambda68._#selFP9#state'" (showCons x1))

d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 :: Curry_CompilerOpts.C_Options
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
d_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 x1 x2 x3 x4 x5 x6 cd cs =
  let x7 = x6
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x1)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Generating Haskell module ") x4 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Files.d_C_writeFileInDir x4 x7 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x1)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing auxiliary info file ") x5 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Files.d_C_writeQTermFileInDir x5 (d_C_extractFuncInfos x3 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x1)
  (Curry_Prelude.toCurryString "Done") cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  x2 cd cs) cd cs) cd cs) cd cs) cd cs) cd cs

nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 :: Curry_CompilerOpts.C_Options
  -> Curry_TransFunctions.C_State -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_OP_compileModule_dot_uscore_hash_lambda66_dot_uscore_hash_lambda68_dot_uscore_hash_lambda70 x1 x2 x3 x4 x5 x6 s cd cs =
  let s13 = s
  in s13 `seq` (let x7 = x6
  in let s12 = leftSupply s13
         s14 = rightSupply s13
         s0 = leftSupply s14
         s11 = rightSupply s14
  in s12 `seq` (s14 `seq` (s0 `seq` (s11 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Generating Haskell module ") x4 cd cs) s0 cd cs) (let s10 = leftSupply s11
                                                         s8 = rightSupply s11
  in s10 `seq` (s8 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Files.d_C_writeFileInDir x4 x7 cd cs) (let s7 = leftSupply s8
                                                    s9 = rightSupply s8
                                                    s1 = leftSupply s9
                                                    s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s1 `seq` (s6 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Writing auxiliary info file ") x5 cd cs) s1 cd cs) (let s5 = leftSupply s6
                                                           s4 = rightSupply s6
  in s5 `seq` (s4 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Files.d_C_writeQTermFileInDir x5 (d_C_extractFuncInfos x3 cd cs) cd cs)
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showDetail x1))
  (Curry_Prelude.toCurryString "Done") s2 cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  x2 cd cs) s3 cd cs)) s5 cd cs)) s7 cd cs)))) s10 cd cs)) s12 cd cs))))

d_C_extractFuncInfos :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Prelude.C_Bool)
d_C_extractFuncInfos x1 cd cs = Curry_Prelude.d_C_map
  d_OP_extractFuncInfos_dot_uscore_hash_lambda72 x1 cd cs

d_OP_extractFuncInfos_dot_withIOResult_dot_101 :: Curry_AbstractHaskell.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_withIOResult_dot_101 x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_TVar x2 -> Curry_Prelude.C_False
  Curry_AbstractHaskell.C_FuncType x3 x4 -> d_OP_extractFuncInfos_dot_withIOResult_dot_101
    x4 cd cs
  Curry_AbstractHaskell.C_TCons x5 x6 -> Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) x5 (Curry_Prelude.OP_Tuple2 (Curry_Names.d_C_curryPrelude cd cs)
    (Curry_Prelude.toCurryString "C_IO")) cd cs
  Curry_AbstractHaskell.C_ForallType x7 x8 x9 -> Curry_Prelude.C_False
  Curry_AbstractHaskell.Choice_C_TypeExpr d i l r -> narrow d i
    (d_OP_extractFuncInfos_dot_withIOResult_dot_101 l cd cs)
    (d_OP_extractFuncInfos_dot_withIOResult_dot_101 r cd cs)
  Curry_AbstractHaskell.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_OP_extractFuncInfos_dot_withIOResult_dot_101 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_TypeExpr d c e -> guardCons d c
    (d_OP_extractFuncInfos_dot_withIOResult_dot_101 e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_TypeExpr d info -> failCons d (traceFail
    "Compile.extractFuncInfos.withIOResult.101" [show x1] info)
  _ -> failCons cd (consFail "Compile.extractFuncInfos.withIOResult.101"
    (showCons x1))

d_OP_extractFuncInfos_dot_isIO_dot_101 :: Curry_AbstractHaskell.C_TypeSig
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_isIO_dot_101 x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_Untyped -> Curry_Prelude.C_False
  Curry_AbstractHaskell.C_CType x2 x3 -> d_OP_extractFuncInfos_dot_withIOResult_dot_101
    x3 cd cs
  Curry_AbstractHaskell.Choice_C_TypeSig d i l r -> narrow d i
    (d_OP_extractFuncInfos_dot_isIO_dot_101 l cd cs)
    (d_OP_extractFuncInfos_dot_isIO_dot_101 r cd cs)
  Curry_AbstractHaskell.Choices_C_TypeSig d i xs -> narrows cs d i (\z ->
    d_OP_extractFuncInfos_dot_isIO_dot_101 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_TypeSig d c e -> guardCons d c
    (d_OP_extractFuncInfos_dot_isIO_dot_101 e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_TypeSig d info -> failCons d (traceFail
    "Compile.extractFuncInfos.isIO.101" [show x1] info)
  _ -> failCons cd (consFail "Compile.extractFuncInfos.isIO.101" (showCons x1))

d_OP_extractFuncInfos_dot_uscore_hash_lambda72 :: Curry_AbstractHaskell.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Prelude.C_Bool
d_OP_extractFuncInfos_dot_uscore_hash_lambda72 x1 cd cs =
  Curry_Prelude.OP_Tuple2 (Curry_AbstractHaskellGoodies.d_C_funcName x1 cd cs)
  (d_OP_extractFuncInfos_dot_isIO_dot_101
  (Curry_AbstractHaskellGoodies.d_C_typeOf x1 cd cs) cd cs)

d_C_patchPreludeExports :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C_patchPreludeExports x1 cd cs = case x1 of
  Curry_AbstractHaskell.C_Prog x2 x3 x4 x5 x6 -> let x7 = Curry_AbstractHaskell.C_Type
                                                       (Curry_Prelude.OP_Tuple2
                                                       (Curry_Names.d_C_curryPrelude
                                                       cd cs)
                                                       (Curry_Prelude.toCurryString
                                                       "C_Apply"))
                                                       Curry_AbstractHaskell.C_Public
                                                       Curry_Prelude.OP_List
                                                       Curry_Prelude.OP_List
                                                     x8 = Curry_AbstractHaskell.C_Type
                                                       (Curry_Prelude.OP_Tuple2
                                                       (Curry_Names.d_C_curryPrelude
                                                       cd cs)
                                                       (Curry_Prelude.toCurryString
                                                       "Curry"))
                                                       Curry_AbstractHaskell.C_Public
                                                       Curry_Prelude.OP_List
                                                       Curry_Prelude.OP_List
                                                     x9 = Curry_AbstractHaskell.C_Func
                                                       Curry_Prelude.OP_List
                                                       (Curry_Prelude.OP_Tuple2
                                                       (Curry_Names.d_C_curryPrelude
                                                       cd cs)
                                                       (Curry_Prelude.toCurryString
                                                       "toCurryString"))
                                                       (Curry_Prelude.C_Int (1))
                                                       Curry_AbstractHaskell.C_Public
                                                       Curry_AbstractHaskell.C_Untyped
                                                       Curry_AbstractHaskell.C_External
    in d_C__case_5 x2 x1 x6 x5 x9 x4 x8 x7 x3
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) x2 (Curry_Names.d_C_curryPrelude cd cs) cd cs) cd cs
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i
    (d_C_patchPreludeExports l cd cs) (d_C_patchPreludeExports r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_patchPreludeExports z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c
    (d_C_patchPreludeExports e cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.patchPreludeExports" [show x1] info)
  _ -> failCons cd (consFail "Compile.patchPreludeExports" (showCons x1))

d_C_compMessage :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C_compMessage x1 x2 x3 x4 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_3 x6 x3 x2 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_compMessage l x2 x3
    x4 cd cs) (d_C_compMessage r x2 x3 x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_compMessage z x2 x3 x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_compMessage e x2 x3
    x4 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.compMessage" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile.compMessage" (showCons x1))

d_C_filterPrelude :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_CompilerOpts.C_Options -> FlatCurry.Annotated.Curry_Types.C_AProg
  t0 -> Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AProg t0
d_C_filterPrelude x1 x2 cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_AProg x3 x4 x5 x6 x7 -> let x8 = Curry_Prelude.d_C_apply
                                                                  (Curry_Prelude.d_C_elem
                                                                  (Curry_CompilerOpts.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CompilerOpts_dot_Extension
                                                                  cd cs)
                                                                  Curry_CompilerOpts.C_NoImplicitPrelude
                                                                  cd cs)
                                                                  (Curry_CompilerOpts.d_C_optExtensions
                                                                  x1 cd cs) cd
                                                                  cs
    in d_C__case_2 x2 x7 x6 x5 x4 x3 x8 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AProg d i l r -> narrow d i
    (d_C_filterPrelude x1 l cd cs) (d_C_filterPrelude x1 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AProg d i xs -> narrows cs d i
    (\z -> d_C_filterPrelude x1 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AProg d c e -> guardCons d c
    (d_C_filterPrelude x1 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AProg d info -> failCons d (traceFail
    "Compile.filterPrelude" [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile.filterPrelude" (showCons x2))

d_C_integrateExternals :: Curry_CompilerOpts.C_Options
  -> Curry_AbstractHaskell.C_Prog -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_integrateExternals x1 x2 x3 cd cs = case x2 of
  Curry_AbstractHaskell.C_Prog x4 x5 x6 x7 x8 -> let x9 = Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# LANGUAGE MagicHash #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# LANGUAGE ScopedTypeVariables #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# LANGUAGE Rank2Types #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# LANGUAGE CPP #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# OPTIONS_GHC -fno-warn-missing-methods #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "#if __GLASGOW_HASKELL__ >= 800")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "#else")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}")
                                                       (Curry_Prelude.OP_Cons
                                                       (Curry_Prelude.toCurryString
                                                       "#endif")
                                                       Curry_Prelude.OP_List))))))))))
                                                     x10 = d_C__case_0 x1 x4
                                                       (Curry_AbstractHaskellPrinter.d_C_defaultOptions
                                                       cd cs) cd cs
    in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C_lookupExternals x1 (Curry_Prelude.d_C_apply
    (Curry_FilePath.d_C_dropExtension cd cs) x3 cd cs) cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda77 x10 x7 x8 x6 x4 x9 x5) cd
    cs
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i
    (d_C_integrateExternals x1 l x3 cd cs) (d_C_integrateExternals x1 r x3 cd
    cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_integrateExternals x1 z x3 cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c
    (d_C_integrateExternals x1 e x3 cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.integrateExternals" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.integrateExternals" (showCons x2))

d_OP_integrateExternals_dot_uscore_hash_lambda77 :: Curry_AbstractHaskellPrinter.C_Options
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeDecl
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda77 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  let x9 = x8
      x10 = d_C_splitExternals x9 cd cs
      x11 = d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas
        x10 cd cs
      x12 = d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps
        x10 cd cs
      x13 = d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls
        x10 cd cs
  in Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_List.d_C_intercalate
  (Curry_Prelude.toCurryString "\n")) (Curry_Prelude.d_C_filter
  (Curry_Utils.d_C_notNull cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_unlines (Curry_Prelude.d_OP_plus_plus x6 x11 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs)
  (Curry_AbstractHaskellPrinter.d_C_ppHeader x1 x5 x4 x2 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs) (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_ppImports x1 cd cs) x7 cd cs) cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_unlines x12 cd cs) cd
  cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply
  (Curry_AbstractHaskellPrinter.d_C_pPrint cd cs)
  (Curry_AbstractHaskellPrinter.d_C_ppDecls x1 x3 x4 x2 cd cs) cd cs)
  (Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "\n") (Curry_Prelude.d_C_unlines x13 cd cs) cd
  cs) Curry_Prelude.OP_List)))))) cd cs) cd cs) cd cs

d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP13_hash_pragmas
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda77._#selFP13#pragmas" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda77._#selFP13#pragmas" (showCons x1))

d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP14_hash_extimps
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda77._#selFP14#extimps" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda77._#selFP14#extimps" (showCons x1))

d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls :: Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls
    l cd cs)
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c
    (d_OP_integrateExternals_dot_uscore_hash_lambda77_dot_uscore_hash_selFP15_hash_extdecls
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile.integrateExternals._#lambda77._#selFP15#extdecls" [show x1] info)
  _ -> failCons cd (consFail
    "Compile.integrateExternals._#lambda77._#selFP15#extdecls" (showCons x1))

d_C_lookupExternals :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_lookupExternals x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply
                                        (Curry_Names.d_C_externalFile cd cs) x2
                                        cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Directory.d_C_doesFileExist x3 cd cs)
  (d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x3) cd cs

d_OP_lookupExternals_dot_uscore_hash_lambda80 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
    "External file found") cd cs) (Curry_IOExts.d_C_readCompleteFile x2 cd cs)
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Message.d_C_showDetail x1 (Curry_Prelude.toCurryString
    "No external file found") cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x2 l cd cs)
    (d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_lookupExternals_dot_uscore_hash_lambda80 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Compile.lookupExternals._#lambda80" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Compile.lookupExternals._#lambda80" (showCons x3))

d_C_splitExternals :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_splitExternals x1 cd cs = let x2 = Curry_Prelude.d_OP_dot
                                    (Curry_Prelude.d_C_reverse cd cs)
                                    (Curry_Prelude.d_OP_dot
                                    (Curry_Prelude.d_C_dropWhile
                                    (Curry_Prelude.d_C_all
                                    Curry_Char.d_C_isSpace cd cs))
                                    (Curry_Prelude.d_C_reverse cd cs) cd cs) cd
                                    cs
                                  x3 = Curry_Prelude.d_C_span
                                    d_OP_splitExternals_dot_isPragma_dot_145
                                    (Curry_Prelude.d_C_lines x1 cd cs) cd cs
                                  x4 = d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas
                                    x3 cd cs
                                  x5 = d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest
                                    x3 cd cs
                                  x6 = Curry_Prelude.d_C_span
                                    d_OP_splitExternals_dot_isImport_dot_145 x5
                                    cd cs
                                  x7 = d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports
                                    x6 cd cs
                                  x8 = d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls
                                    x6 cd cs
  in Curry_Prelude.OP_Tuple3 (Curry_Prelude.d_C_apply x2 x4 cd cs)
  (Curry_Prelude.d_C_apply x2 x7 cd cs) x8

d_OP_splitExternals_dot_isPragma_dot_145 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isPragma_dot_145 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs)
  x1 cd cs) (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.toCurryString "{-#") x1 cd cs) cd cs

d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP20_hash_pragmas e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP20#pragmas" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP20#pragmas"
    (showCons x1))

d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP21_hash_rest e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP21#rest" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP21#rest" (showCons
    x1))

d_OP_splitExternals_dot_isComment_dot_145 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isComment_dot_145 x1 cd cs = Curry_Prelude.d_OP_amp_amp
  (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.toCurryString "-- ") x1 cd cs) (Curry_Prelude.d_C_not
  (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.toCurryString "-- #endimport") x1 cd cs) cd cs) cd cs

d_OP_splitExternals_dot_isImport_dot_145 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_splitExternals_dot_isImport_dot_145 x1 cd cs = Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_all Curry_Char.d_C_isSpace cd cs)
  x1 cd cs) (Curry_Prelude.d_OP_bar_bar (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.toCurryString "import") x1 cd cs)
  (Curry_Prelude.d_OP_bar_bar (Curry_List.d_C_isPrefixOf
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.toCurryString "#") x1 cd cs)
  (d_OP_splitExternals_dot_isComment_dot_145 x1 cd cs) cd cs) cd cs) cd cs

d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP18_hash_imports e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP18#imports" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP18#imports"
    (showCons x1))

d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls l cd cs)
    (d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_splitExternals_dot_uscore_hash_selFP19_hash_decls e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile.splitExternals._#selFP19#decls" [show x1] info)
  _ -> failCons cd (consFail "Compile.splitExternals._#selFP19#decls" (showCons
    x1))

d_C_dump :: Curry_CompilerOpts.C_DumpFormat -> Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_dump x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_when
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem
  (Curry_CompilerOpts.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_CompilerOpts_dot_DumpFormat
  cd cs) x1 cd cs) (Curry_CompilerOpts.d_C_optDump x2 cd cs) cd cs))
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showDetail x2)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "Dumping ") x3 cd
  cs) cd cs) (Curry_Files.d_C_writeFileInDir (Curry_Files.d_C_withDirectory
  (Curry_Prelude.d_C_flip (Curry_FilePath.d_OP_lt_slash_gt cd cs)
  (Curry_CompilerOpts.d_C_optOutputSubdir x2 cd cs)) x3 cd cs) x4 cd cs) cd cs)
  cd cs

d_C_rename :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_Prog
d_C_rename x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> let x7 = Curry_Prelude.d_C_apply
                                                       (FlatCurry.Curry_Goodies.d_C_updQNamesInProg
                                                       (Curry_Names.d_C_renameQName
                                                       cd cs) cd cs) x1 cd cs
                                                     x8 = d_OP_rename_dot_uscore_hash_selFP23_hash_td
                                                       x7 cd cs
                                                     x9 = d_OP_rename_dot_uscore_hash_selFP24_hash_fd
                                                       x7 cd cs
                                                     x10 = d_OP_rename_dot_uscore_hash_selFP25_hash_od
                                                       x7 cd cs
    in FlatCurry.Curry_Types.C_Prog (Curry_Prelude.d_C_apply
    (Curry_Names.d_C_renameModule cd cs) x2 cd cs) (Curry_Prelude.d_C_map
    (Curry_Names.d_C_renameModule cd cs) x3 cd cs) x8 x9 x10
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C_rename l cd cs)
    (d_C_rename r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_rename z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c (d_C_rename e cd $!
    addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP23_hash_td :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl
d_OP_rename_dot_uscore_hash_selFP23_hash_td x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> x4
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP23_hash_td l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP23_hash_td r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP23_hash_td z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP23_hash_td e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP23#td" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP23#td" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP24_hash_fd :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl
d_OP_rename_dot_uscore_hash_selFP24_hash_fd x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> x5
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP24_hash_fd l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP24_hash_fd r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP24_hash_fd z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP24_hash_fd e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP24#fd" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP24#fd" (showCons x1))

d_OP_rename_dot_uscore_hash_selFP25_hash_od :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl
d_OP_rename_dot_uscore_hash_selFP25_hash_od x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> x6
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_rename_dot_uscore_hash_selFP25_hash_od l cd cs)
    (d_OP_rename_dot_uscore_hash_selFP25_hash_od r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_rename_dot_uscore_hash_selFP25_hash_od z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_rename_dot_uscore_hash_selFP25_hash_od e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "Compile.rename._#selFP25#od" [show x1] info)
  _ -> failCons cd (consFail "Compile.rename._#selFP25#od" (showCons x1))

d_C_defaultModules :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_defaultModules cd cs = Curry_Prelude.OP_Cons (Curry_Names.d_C_basics cd cs)
  Curry_Prelude.OP_List

d_C_fst3 :: forall t1 t2 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 t0 t1 t2 -> Cover
  -> ConstStore -> t0
d_C_fst3 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (d_C_fst3 l cd cs)
    (d_C_fst3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> d_C_fst3 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (d_C_fst3 e cd $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail "Compile.fst3"
    [show x1] info)
  _ -> failCons cd (consFail "Compile.fst3" (showCons x1))

d_C__case_0 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_AbstractHaskellPrinter.C_Options -> Cover
  -> ConstStore -> Curry_AbstractHaskellPrinter.C_Options
d_C__case_0 x1 x4 x13 cd cs = case x13 of
  Curry_AbstractHaskellPrinter.C_Options x11 x12 -> Curry_AbstractHaskellPrinter.C_Options
    x4 (Curry_CompilerOpts.d_C_optTraceFailure x1 cd cs)
  Curry_AbstractHaskellPrinter.Choice_C_Options d i l r -> narrow d i
    (d_C__case_0 x1 x4 l cd cs) (d_C__case_0 x1 x4 r cd cs)
  Curry_AbstractHaskellPrinter.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_0 x1 x4 z cd cs) xs
  Curry_AbstractHaskellPrinter.Guard_C_Options d c e -> guardCons d c
    (d_C__case_0 x1 x4 e cd $! addCs c cs)
  Curry_AbstractHaskellPrinter.Fail_C_Options d info -> failCons d (traceFail
    "Compile._case_0" [show x1, show x4, show x13] info)
  _ -> failCons cd (consFail "Compile._case_0" (showCons x13))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AProg t0 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AProg t0
d_C__case_2 x2 x7 x6 x5 x4 x3 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> FlatCurry.Annotated.Curry_Types.C_AProg x3
    (Curry_Prelude.d_C_filter (Curry_Prelude.d_C_flip
    (Curry_Prelude.d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) (Curry_Names.d_C_prelude cd cs)) x4 cd cs) x5 x6 x7
  Curry_Prelude.C_False -> d_C__case_1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x2 x7 x6 x5 x4
    x3 l cd cs) (d_C__case_2 x2 x7 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x2 x7
    x6 x5 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x2 x7 x6 x5 x4
    x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_2"
    [show x2, show x7, show x6, show x5, show x4, show x3, show x8] info)
  _ -> failCons cd (consFail "Compile._case_2" (showCons x8))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AProg t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AProg t0
d_C__case_1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x2 l cd cs)
    (d_C__case_1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_1"
    [show x2, show x3] info)
  _ -> failCons cd (consFail "Compile._case_1" (showCons x3))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x6 x3 x2 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let x9 = Curry_Prelude.d_C_apply
                                         (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int
                                         cd cs) x6 cd cs
    in Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_lpad
    (Curry_Prelude.d_C_length x9 cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Prelude_dot_Int
    cd cs) x5 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " of ") (Curry_Prelude.d_OP_plus_plus x9
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "]")
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_rpad (Curry_Prelude.C_Int
    (9)) x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#)
    (Curry_Prelude.d_OP_plus_plus (Curry_Utils.d_C_rpad (Curry_Prelude.C_Int
    (16)) x3 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    " ( ") (Curry_Prelude.d_OP_plus_plus (Curry_FilePath.d_C_normalise x7 cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ", ")
    (Curry_Prelude.d_OP_plus_plus (Curry_FilePath.d_C_normalise x8 cd cs)
    (Curry_Prelude.toCurryString " )") cd cs) cd cs) cd cs) cd cs) cd cs)) cd
    cs)) cd cs) cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 x6 x3 x2 x5
    l cd cs) (d_C__case_3 x6 x3 x2 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 x6
    x3 x2 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_3 x6 x3 x2 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_3"
    [show x6, show x3, show x2, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_3" (showCons x4))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_AbstractHaskell.C_Prog -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_OpDecl -> Curry_Prelude.OP_List
  Curry_AbstractHaskell.C_FuncDecl -> Curry_AbstractHaskell.C_FuncDecl
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeDecl
  -> Curry_AbstractHaskell.C_TypeDecl -> Curry_AbstractHaskell.C_TypeDecl
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_C__case_5 x2 x1 x6 x5 x9 x4 x8 x7 x3 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_AbstractHaskell.C_Prog x2 x3
    (Curry_Prelude.OP_Cons x7 (Curry_Prelude.OP_Cons x8 x4))
    (Curry_Prelude.OP_Cons x9 x5) x6
  Curry_Prelude.C_False -> d_C__case_4 x1 (Curry_Prelude.d_C_otherwise cd cs) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x2 x1 x6 x5 x9
    x4 x8 x7 x3 l cd cs) (d_C__case_5 x2 x1 x6 x5 x9 x4 x8 x7 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x2 x1
    x6 x5 x9 x4 x8 x7 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x2 x1 x6 x5 x9
    x4 x8 x7 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_5"
    [show x2, show x1, show x6, show x5, show x9, show x4, show x8, show x7
    , show x3, show x10] info)
  _ -> failCons cd (consFail "Compile._case_5" (showCons x10))

d_C__case_4 :: Curry_AbstractHaskell.C_Prog -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_C__case_4 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x1 l cd cs)
    (d_C__case_4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Compile._case_4" (showCons x2))

d_C__case_7 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_TransFunctions.C_State
d_C__case_7 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_6 x3 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x3 l cd cs)
    (d_C__case_7 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_7 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_7"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Compile._case_7" (showCons x2))

nd_C__case_7 :: Curry_TransFunctions.C_State -> Curry_Prelude.OP_Tuple2
  Curry_AbstractHaskell.C_Prog (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_TransFunctions.C_State
nd_C__case_7 x3 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_6 x3 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_7 x3 l s cd
    cs) (nd_C__case_7 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_7
    x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_7 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_7"
    [show x3, show x2] info)
  _ -> failCons cd (consFail "Compile._case_7" (showCons x2))

d_C__case_6 :: Curry_TransFunctions.C_State -> Curry_AbstractHaskell.C_Prog
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_6 x3 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x3
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_6 x3 l cd
    cs) (d_C__case_6 x3 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_6 x3 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_6 x3 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_6" [show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_6" (showCons x4))

nd_C__case_6 :: Curry_TransFunctions.C_State -> Curry_AbstractHaskell.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_6 x3 x4 s cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x3
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (nd_C__case_6 x3 l s
    cd cs) (nd_C__case_6 x3 r s cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C__case_6 x3 z s cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (nd_C__case_6 x3 e s
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_6" [show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_6" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_C__case_9 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_8 x5 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_9 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Compile._case_9" (showCons x2))

nd_C__case_9 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_C__case_9 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_8 x5 x4 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_9 l s cd cs)
    (nd_C__case_9 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_9 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_9 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Compile._case_9"
    [show x2] info)
  _ -> failCons cd (consFail "Compile._case_9" (showCons x2))

d_C__case_8 :: Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Curry_AbstractHaskell.C_Prog -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
d_C__case_8 x5 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x5
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_8 x5 l cd
    cs) (d_C__case_8 x5 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_8 x5 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_8 x5 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_8" [show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_8" (showCons x4))

nd_C__case_8 :: Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass) -> Curry_AbstractHaskell.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple5
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)
nd_C__case_8 x5 x4 s cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x5
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (nd_C__case_8 x5 l s
    cd cs) (nd_C__case_8 x5 r s cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C__case_8 x5 z s cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (nd_C__case_8 x5 e s
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_8" [show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_8" (showCons x4))

d_C__case_11 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_C__case_11 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_10 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_11 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_11" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_11" (showCons x2))

nd_C__case_11 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
nd_C__case_11 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_10 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_11 l s cd cs)
    (nd_C__case_11 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_11
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_11 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_11" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_11" (showCons x2))

d_C__case_10 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_OpDecl
d_C__case_10 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x10
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_10 l cd
    cs) (d_C__case_10 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_10 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_10 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_10" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_10" (showCons x4))

d_C__case_13 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_C__case_13 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_12 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_13 l cd cs)
    (d_C__case_13 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_13 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_13 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_13" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_13" (showCons x2))

nd_C__case_13 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
nd_C__case_13 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_12 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_13 l s cd cs)
    (nd_C__case_13 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_13
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_13 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_13" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_13" (showCons x2))

d_C__case_12 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_C__case_12 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x9
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_12 l cd
    cs) (d_C__case_12 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_12 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_12 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_12" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_12" (showCons x4))

d_C__case_15 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_15 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_14 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_15 l cd cs)
    (d_C__case_15 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_15 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_15 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_15" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_15" (showCons x2))

nd_C__case_15 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C__case_15 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_14 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_15 l s cd cs)
    (nd_C__case_15 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_15
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_15 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_15" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_15" (showCons x2))

d_C__case_14 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_14 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x7
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_14 l cd
    cs) (d_C__case_14 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_14 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_14 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_14" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_14" (showCons x4))

d_C__case_17 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_17 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_16 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_17 l cd cs)
    (d_C__case_17 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_17 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_17 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_17" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_17" (showCons x2))

nd_C__case_17 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_C__case_17 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_16 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_17 l s cd cs)
    (nd_C__case_17 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_17
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_17 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_17" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_17" (showCons x2))

d_C__case_16 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_16 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x6
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_16 l cd
    cs) (d_C__case_16 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_16 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_16 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_16" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_16" (showCons x4))

d_C__case_19 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C__case_19 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_18 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_19 l cd cs)
    (d_C__case_19 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_19 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_19 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_19" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_19" (showCons x2))

nd_C__case_19 :: Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Prog
  (Curry_Prelude.OP_Tuple5 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_NDClass) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_TypeHOClass)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_FuncHOClass)) -> IDSupply -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
nd_C__case_19 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_18 x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_19 l s cd cs)
    (nd_C__case_19 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_19
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_19 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_19" [show x2] info)
  _ -> failCons cd (consFail "Compile._case_19" (showCons x2))

d_C__case_18 :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore
  -> Curry_AbstractHaskell.C_Prog
d_C__case_18 x4 cd cs = case x4 of
  Curry_AbstractHaskell.C_Prog x6 x7 x8 x9 x10 -> x4
  Curry_AbstractHaskell.Choice_C_Prog d i l r -> narrow d i (d_C__case_18 l cd
    cs) (d_C__case_18 r cd cs)
  Curry_AbstractHaskell.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C__case_18 z cd cs) xs
  Curry_AbstractHaskell.Guard_C_Prog d c e -> guardCons d c (d_C__case_18 e
    cd $! addCs c cs)
  Curry_AbstractHaskell.Fail_C_Prog d info -> failCons d (traceFail
    "Compile._case_18" [show x4] info)
  _ -> failCons cd (consFail "Compile._case_18" (showCons x4))

d_C__case_21 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_21 x2 x1 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_20 x6 x2 x1 x5 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_21 x2 x1 x5 l
    cd cs) (d_C__case_21 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_21
    x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_21 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_21" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_21" (showCons x4))

nd_C__case_21 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_21 x2 x1 x5 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_20 x6 x2 x1 x5 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_21 x2 x1 x5 l
    s cd cs) (nd_C__case_21 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_21
    x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_21 x2 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_21" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_21" (showCons x4))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_20 x6 x2 x1 x5 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let x11 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_tfcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "Typed")) x6 cd cs) cd cs
                                           x12 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_tfcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "ExtImports")) x6 cd cs) cd cs
                                           x13 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_tfcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "Lifted")) x6 cd cs) cd cs
                                           x14 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_tfcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "ElimCond")) x6 cd cs) cd cs
                                           x15 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_tfcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "Defaulted")) x6 cd cs) cd cs
                                           x16 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_fcyFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "Renamed")) x6 cd cs) cd cs
                                           x17 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_ahsFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "FunDecls")) x6 cd cs) cd cs
                                           x18 = Curry_Prelude.d_OP_dollar
                                             d_OP_compileModule_dot_ahsFile_dot_53
                                             (Curry_Files.d_C_withBaseName
                                             (Curry_Prelude.d_C_flip (acceptCs
                                             id Curry_Prelude.d_OP_plus_plus)
                                             (Curry_Prelude.toCurryString
                                             "TypeDecls")) x6 cd cs) cd cs
                                           x19 = d_OP_compileModule_dot_ahsFile_dot_53
                                             x6 cd cs
                                           x20 = Curry_TransFunctions.d_C_compOptions
                                             x2 cd cs
                                           x21 = Curry_Names.d_C_destFile
                                             (Curry_CompilerOpts.d_C_optTraceFailure
                                             x20 cd cs)
                                             (Curry_CompilerOpts.d_C_optOutputSubdir
                                             x20 cd cs) x6 x8 cd cs
                                           x22 = Curry_Names.d_C_funcInfoFile
                                             (Curry_CompilerOpts.d_C_optOutputSubdir
                                             x20 cd cs) x6 x8 cd cs
    in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IOExts.d_C_readCompleteFile x10 cd cs)
    (d_OP_compileModule_dot_uscore_hash_lambda66 x20 x5 x1 x2 x19 x15 x21 x14
    x12 x8 x17 x22 x13 x6 x16 x18 x11) cd cs
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (d_C__case_20 x6 x2 x1 x5
    l cd cs) (d_C__case_20 x6 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> d_C__case_20
    x6 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (d_C__case_20 x6 x2 x1 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_20" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_20" (showCons x7))

nd_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_20 x6 x2 x1 x5 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let s26 = s
    in s26 `seq` (let s27 = leftSupply s26
                      s31 = rightSupply s26
                      s28 = leftSupply s27
                      s29 = rightSupply s27
                      s2 = leftSupply s28
                      s5 = rightSupply s28
                      s8 = leftSupply s29
                      s30 = rightSupply s29
                      s11 = leftSupply s30
                      s14 = rightSupply s30
                      s32 = leftSupply s31
                      s33 = rightSupply s31
                      s17 = leftSupply s32
                      s20 = rightSupply s32
                      s23 = leftSupply s33
                      s34 = rightSupply s33
                      s24 = leftSupply s34
                      s25 = rightSupply s34
    in s27 `seq` (s31 `seq` (s28 `seq` (s29 `seq` (s2 `seq` (s5 `seq` (s8 `seq`
    (s30 `seq` (s11 `seq` (s14 `seq` (s32 `seq` (s33 `seq` (s17 `seq` (s20 `seq`
    (s23 `seq` (s34 `seq` (s24 `seq` (s25 `seq` (let x11 = let s1 = leftSupply
                                                                 s2
                                                               s0 = rightSupply
                                                                 s2
                                                       in s1 `seq` (s0 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_tfcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "Typed"))) x6 s0 cd cs)
                                                       s1 cd cs)
                                                     x12 = let s4 = leftSupply
                                                                 s5
                                                               s3 = rightSupply
                                                                 s5
                                                       in s4 `seq` (s3 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_tfcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "ExtImports"))) x6 s3 cd
                                                       cs) s4 cd cs)
                                                     x13 = let s7 = leftSupply
                                                                 s8
                                                               s6 = rightSupply
                                                                 s8
                                                       in s7 `seq` (s6 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_tfcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "Lifted"))) x6 s6 cd cs)
                                                       s7 cd cs)
                                                     x14 = let s10 = leftSupply
                                                                 s11
                                                               s9 = rightSupply
                                                                 s11
                                                       in s10 `seq` (s9 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_tfcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "ElimCond"))) x6 s9 cd
                                                       cs) s10 cd cs)
                                                     x15 = let s13 = leftSupply
                                                                 s14
                                                               s12 = rightSupply
                                                                 s14
                                                       in s13 `seq` (s12 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_tfcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "Defaulted"))) x6 s12 cd
                                                       cs) s13 cd cs)
                                                     x16 = let s16 = leftSupply
                                                                 s17
                                                               s15 = rightSupply
                                                                 s17
                                                       in s16 `seq` (s15 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_fcyFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "Renamed"))) x6 s15 cd
                                                       cs) s16 cd cs)
                                                     x17 = let s19 = leftSupply
                                                                 s20
                                                               s18 = rightSupply
                                                                 s20
                                                       in s19 `seq` (s18 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_ahsFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "FunDecls"))) x6 s18 cd
                                                       cs) s19 cd cs)
                                                     x18 = let s22 = leftSupply
                                                                 s23
                                                               s21 = rightSupply
                                                                 s23
                                                       in s22 `seq` (s21 `seq`
                                                       Curry_Prelude.nd_OP_dollar
                                                       (wrapDX id
                                                       d_OP_compileModule_dot_ahsFile_dot_53)
                                                       (Curry_Files.nd_C_withBaseName
                                                       (wrapNX id
                                                       (Curry_Prelude.nd_C_flip
                                                       (wrapDX (wrapDX id)
                                                       (acceptCs id
                                                       Curry_Prelude.d_OP_plus_plus))
                                                       (Curry_Prelude.toCurryString
                                                       "TypeDecls"))) x6 s21 cd
                                                       cs) s22 cd cs)
                                                     x19 = d_OP_compileModule_dot_ahsFile_dot_53
                                                       x6 cd cs
                                                     x20 = Curry_TransFunctions.nd_C_compOptions
                                                       x2 s24 cd cs
                                                     x21 = Curry_Names.d_C_destFile
                                                       (Curry_CompilerOpts.d_C_optTraceFailure
                                                       x20 cd cs)
                                                       (Curry_CompilerOpts.d_C_optOutputSubdir
                                                       x20 cd cs) x6 x8 cd cs
                                                     x22 = Curry_Names.d_C_funcInfoFile
                                                       (Curry_CompilerOpts.d_C_optOutputSubdir
                                                       x20 cd cs) x6 x8 cd cs
    in Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IOExts.d_C_readCompleteFile x10 cd cs) (wrapNX id
    (nd_OP_compileModule_dot_uscore_hash_lambda66 x20 x5 x1 x2 x19 x15 x21 x14
    x12 x8 x17 x22 x13 x6 x16 x18 x11)) s25 cd cs)))))))))))))))))))
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (nd_C__case_20 x6 x2 x1
    x5 l s cd cs) (nd_C__case_20 x6 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> nd_C__case_20
    x6 x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (nd_C__case_20 x6 x2 x1
    x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_20" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_20" (showCons x7))

d_C__case_22 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_FuncHOClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_TransFunctions.C_State
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_22 x7 x6 x5 x4 x3 x1 cd cs = case x1 of
  Curry_TransFunctions.C_State x8 x9 x10 x11 x12 x13 x14 x15 -> Curry_TransFunctions.C_State
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) cd cs) (Curry_TransFunctions.d_C_typeMap x1 cd cs) x3 cd cs)
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) cd cs) (Curry_TransFunctions.d_C_ndResult x1 cd cs) x4 cd cs)
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) cd cs) (Curry_TransFunctions.d_C_hoResultType x1 cd cs) x5 cd cs)
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) cd cs) (Curry_TransFunctions.d_C_hoResultCons x1 cd cs) x6 cd cs)
    (Curry_FiniteMap.d_C_plusFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) cd cs) (Curry_TransFunctions.d_C_hoResultFunc x1 cd cs) x7 cd cs)
    x13 x14 x15
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (d_C__case_22 x7 x6
    x5 x4 x3 l cd cs) (d_C__case_22 x7 x6 x5 x4 x3 r cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    d_C__case_22 x7 x6 x5 x4 x3 z cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (d_C__case_22 x7 x6
    x5 x4 x3 e cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_22" [show x7, show x6, show x5, show x4, show x3, show x1]
    info)
  _ -> failCons cd (consFail "Compile._case_22" (showCons x1))

nd_C__case_22 :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) Curry_Classification.C_FuncHOClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_ConsHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  Curry_Classification.C_TypeHOClass -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Classification.C_NDClass
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_TransFunctions.C_State
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_22 x7 x6 x5 x4 x3 x1 s cd cs = case x1 of
  Curry_TransFunctions.C_State x8 x9 x10 x11 x12 x13 x14 x15 -> let s65 = s
    in s65 `seq` (let s66 = leftSupply s65
                      s67 = rightSupply s65
                      s11 = leftSupply s66
                      s24 = rightSupply s66
                      s37 = leftSupply s67
                      s68 = rightSupply s67
                      s50 = leftSupply s68
                      s63 = rightSupply s68
    in s66 `seq` (s67 `seq` (s11 `seq` (s24 `seq` (s37 `seq` (s68 `seq`
    (s50 `seq` (s63 `seq` Curry_TransFunctions.C_State (let s10 = leftSupply s11
                                                            s12 = rightSupply
                                                              s11
                                                            s7 = leftSupply s12
                                                            s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s7 `seq` (s9 `seq` Curry_FiniteMap.nd_C_plusFM
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s2 = leftSupply s8
         s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s2 `seq` (s5 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s0 cd cs) s1 cd cs)) (let s4 = leftSupply s5
                              s3 = rightSupply s5
    in s4 `seq` (s3 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s3 cd cs) s4 cd cs)) s6 cd cs)))) (Curry_TransFunctions.nd_C_typeMap x1 s9
    cd cs) x3 s10 cd cs)))) (let s23 = leftSupply s24
                                 s25 = rightSupply s24
                                 s20 = leftSupply s25
                                 s22 = rightSupply s25
    in s23 `seq` (s25 `seq` (s20 `seq` (s22 `seq` Curry_FiniteMap.nd_C_plusFM
    (let s19 = leftSupply s20
         s21 = rightSupply s20
         s15 = leftSupply s21
         s18 = rightSupply s21
    in s19 `seq` (s21 `seq` (s15 `seq` (s18 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (let s14 = leftSupply s15
         s13 = rightSupply s15
    in s14 `seq` (s13 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s13 cd cs) s14 cd cs)) (let s17 = leftSupply s18
                                s16 = rightSupply s18
    in s17 `seq` (s16 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s16 cd cs) s17 cd cs)) s19 cd cs)))) (Curry_TransFunctions.nd_C_ndResult x1
    s22 cd cs) x4 s23 cd cs)))) (let s36 = leftSupply s37
                                     s38 = rightSupply s37
                                     s33 = leftSupply s38
                                     s35 = rightSupply s38
    in s36 `seq` (s38 `seq` (s33 `seq` (s35 `seq` Curry_FiniteMap.nd_C_plusFM
    (let s32 = leftSupply s33
         s34 = rightSupply s33
         s28 = leftSupply s34
         s31 = rightSupply s34
    in s32 `seq` (s34 `seq` (s28 `seq` (s31 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (let s27 = leftSupply s28
         s26 = rightSupply s28
    in s27 `seq` (s26 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s26 cd cs) s27 cd cs)) (let s30 = leftSupply s31
                                s29 = rightSupply s31
    in s30 `seq` (s29 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s29 cd cs) s30 cd cs)) s32 cd cs)))) (Curry_TransFunctions.nd_C_hoResultType
    x1 s35 cd cs) x5 s36 cd cs)))) (let s49 = leftSupply s50
                                        s51 = rightSupply s50
                                        s46 = leftSupply s51
                                        s48 = rightSupply s51
    in s49 `seq` (s51 `seq` (s46 `seq` (s48 `seq` Curry_FiniteMap.nd_C_plusFM
    (let s45 = leftSupply s46
         s47 = rightSupply s46
         s41 = leftSupply s47
         s44 = rightSupply s47
    in s45 `seq` (s47 `seq` (s41 `seq` (s44 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (let s40 = leftSupply s41
         s39 = rightSupply s41
    in s40 `seq` (s39 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s39 cd cs) s40 cd cs)) (let s43 = leftSupply s44
                                s42 = rightSupply s44
    in s43 `seq` (s42 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s42 cd cs) s43 cd cs)) s45 cd cs)))) (Curry_TransFunctions.nd_C_hoResultCons
    x1 s48 cd cs) x6 s49 cd cs)))) (let s62 = leftSupply s63
                                        s64 = rightSupply s63
                                        s59 = leftSupply s64
                                        s61 = rightSupply s64
    in s62 `seq` (s64 `seq` (s59 `seq` (s61 `seq` Curry_FiniteMap.nd_C_plusFM
    (let s58 = leftSupply s59
         s60 = rightSupply s59
         s54 = leftSupply s60
         s57 = rightSupply s60
    in s58 `seq` (s60 `seq` (s54 `seq` (s57 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
    (let s53 = leftSupply s54
         s52 = rightSupply s54
    in s53 `seq` (s52 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s52 cd cs) s53 cd cs)) (let s56 = leftSupply s57
                                s55 = rightSupply s57
    in s56 `seq` (s55 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s55 cd cs) s56 cd cs)) s58 cd cs)))) (Curry_TransFunctions.nd_C_hoResultFunc
    x1 s61 cd cs) x7 s62 cd cs)))) x13 x14 x15))))))))
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (nd_C__case_22 x7 x6
    x5 x4 x3 l s cd cs) (nd_C__case_22 x7 x6 x5 x4 x3 r s cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    nd_C__case_22 x7 x6 x5 x4 x3 z s cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (nd_C__case_22 x7 x6
    x5 x4 x3 e s cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_22" [show x7, show x6, show x5, show x4, show x3, show x1]
    info)
  _ -> failCons cd (consFail "Compile._case_22" (showCons x1))

d_C__case_24 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_24 x2 x1 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_23 x6 x2 x1 x5 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_24 x2 x1 x5 l
    cd cs) (d_C__case_24 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_24
    x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_24 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_24" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_24" (showCons x4))

nd_C__case_24 :: Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_24 x2 x1 x5 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_23 x6 x2 x1 x5 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_24 x2 x1 x5 l
    s cd cs) (nd_C__case_24 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_24
    x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_24 x2 x1 x5 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_24" [show x2, show x1, show x5, show x4] info)
  _ -> failCons cd (consFail "Compile._case_24" (showCons x4))

d_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_23 x6 x2 x1 x5 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let x11 = Curry_TransFunctions.d_C_compOptions
                                             x2 cd cs
                                           x12 = Curry_Names.d_C_analysisFile
                                             (Curry_CompilerOpts.d_C_optOutputSubdir
                                             x11 cd cs) x6 x8 cd cs
    in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showStatus x11)
    (d_C_compMessage (Curry_Prelude.OP_Tuple2 x5 x1)
    (Curry_Prelude.toCurryString "Analyzing") x6 (Curry_Prelude.OP_Tuple2 x8
    x12) cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C_readAnalysis x11 x6 x8 cd cs)
    (d_OP_loadAnalysis_dot_uscore_hash_lambda52 x2) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (d_C__case_23 x6 x2 x1 x5
    l cd cs) (d_C__case_23 x6 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> d_C__case_23
    x6 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (d_C__case_23 x6 x2 x1 x5
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_23" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_23" (showCons x7))

nd_C__case_23 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_23 x6 x2 x1 x5 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let s8 = s
    in s8 `seq` (let s0 = leftSupply s8
                     s6 = rightSupply s8
    in s0 `seq` (s6 `seq` (let x11 = Curry_TransFunctions.nd_C_compOptions x2 s0
                                 cd cs
                               x12 = Curry_Names.d_C_analysisFile
                                 (Curry_CompilerOpts.d_C_optOutputSubdir x11 cd
                                 cs) x6 x8 cd cs
    in let s5 = leftSupply s6
           s7 = rightSupply s6
           s1 = leftSupply s7
           s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.nd_OP_dollar (wrapDX id (Curry_Message.d_C_showStatus x11))
    (d_C_compMessage (Curry_Prelude.OP_Tuple2 x5 x1)
    (Curry_Prelude.toCurryString "Analyzing") x6 (Curry_Prelude.OP_Tuple2 x8
    x12) cd cs) s1 cd cs) (let s3 = leftSupply s4
                               s2 = rightSupply s4
    in s3 `seq` (s2 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (nd_C_readAnalysis x11 x6 x8 s2 cd cs) (wrapNX id
    (nd_OP_loadAnalysis_dot_uscore_hash_lambda52 x2)) s3 cd cs)) s5 cd cs))))))
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (nd_C__case_23 x6 x2 x1
    x5 l s cd cs) (nd_C__case_23 x6 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> nd_C__case_23
    x6 x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (nd_C__case_23 x6 x2 x1
    x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_23" [show x6, show x2, show x1, show x5, show x7] info)
  _ -> failCons cd (consFail "Compile._case_23" (showCons x7))

d_C__case_25 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_25 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x2 l cd cs)
    (d_C__case_25 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_25 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_25"
    [show x2, show x7] info)
  _ -> failCons cd (consFail "Compile._case_25" (showCons x7))

d_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_29 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_28 x1 x2 x3 x6 x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_29 x1 x2 x3 l
    cd cs) (d_C__case_29 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_29
    x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_29 x1 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_29" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_29" (showCons x4))

nd_C__case_29 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_29 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_28 x1 x2 x3 x6 x7 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_29 x1 x2 x3 l
    s cd cs) (nd_C__case_29 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_29
    x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_29 x1 x2 x3 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Compile._case_29" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Compile._case_29" (showCons x4))

d_C__case_28 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_28 x1 x2 x3 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let x11 = Curry_Prelude.d_C_apply
                                             (Curry_Names.d_C_externalFile cd
                                             cs) x8 cd cs
                                           x12 = Curry_TransFunctions.d_C_compOptions
                                             x2 cd cs
                                           x13 = Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
                                             (Curry_Directory.d_C_doesFileExist
                                             x11 cd cs)
                                             (d_OP_makeModule_dot_uscore_hash_lambda45
                                             x12 x11 x8 x9 x1) cd cs
                                           x14 = Curry_Prelude.d_C_length x1 cd
                                             cs
    in d_C__case_27 x12 x3 x6 x8 x2 x14 x13 (Curry_CompilerOpts.d_C_optForce x12
    cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (d_C__case_28 x1 x2 x3 x6
    l cd cs) (d_C__case_28 x1 x2 x3 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> d_C__case_28
    x1 x2 x3 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (d_C__case_28 x1 x2 x3 x6
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_28" [show x1, show x2, show x3, show x6, show x7] info)
  _ -> failCons cd (consFail "Compile._case_28" (showCons x7))

nd_C__case_28 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_28 x1 x2 x3 x6 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Tuple3 x8 x9 x10 -> let s4 = s
    in s4 `seq` (let s5 = leftSupply s4
                     s6 = rightSupply s4
                     s0 = leftSupply s5
                     s1 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
    (let x11 = Curry_Prelude.nd_C_apply (wrapDX id (Curry_Names.d_C_externalFile
           cd cs)) x8 s0 cd cs
         x12 = Curry_TransFunctions.nd_C_compOptions x2 s1 cd cs
         x13 = Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
           (Curry_Directory.d_C_doesFileExist x11 cd cs) (wrapDX id
           (d_OP_makeModule_dot_uscore_hash_lambda45 x12 x11 x8 x9 x1)) s2 cd cs
         x14 = Curry_Prelude.d_C_length x1 cd cs
    in nd_C__case_27 x12 x3 x6 x8 x2 x14 x13 (Curry_CompilerOpts.d_C_optForce
    x12 cd cs) s3 cd cs)))))))
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (nd_C__case_28 x1 x2 x3
    x6 l s cd cs) (nd_C__case_28 x1 x2 x3 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> nd_C__case_28
    x1 x2 x3 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (nd_C__case_28 x1 x2 x3
    x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Compile._case_28" [show x1, show x2, show x3, show x6, show x7] info)
  _ -> failCons cd (consFail "Compile._case_28" (showCons x7))

d_C__case_27 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_27 x12 x3 x6 x8 x2 x14 x13 x15 cd cs = case x15 of
  Curry_Prelude.C_True -> d_C_compileModule x14 x2 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_26 x3 x6 x8 x2 x14 x12 x13
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x12 x3 x6 x8
    x2 x14 x13 l cd cs) (d_C__case_27 x12 x3 x6 x8 x2 x14 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x12
    x3 x6 x8 x2 x14 x13 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_27 x12 x3 x6 x8
    x2 x14 x13 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_27"
    [show x12, show x3, show x6, show x8, show x2, show x14, show x13, show x15]
    info)
  _ -> failCons cd (consFail "Compile._case_27" (showCons x15))

nd_C__case_27 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
nd_C__case_27 x12 x3 x6 x8 x2 x14 x13 x15 s cd cs = case x15 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C_compileModule x14 x2 x3 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_26 x3 x6 x8 x2 x14 x12 x13
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x12 x3 x6 x8
    x2 x14 x13 l s cd cs) (nd_C__case_27 x12 x3 x6 x8 x2 x14 x13 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x12
    x3 x6 x8 x2 x14 x13 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_27 x12 x3 x6 x8
    x2 x14 x13 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_27"
    [show x12, show x3, show x6, show x8, show x2, show x14, show x13, show x15]
    info)
  _ -> failCons cd (consFail "Compile._case_27" (showCons x15))

d_C__case_26 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO Curry_TransFunctions.C_State
d_C__case_26 x3 x6 x8 x2 x14 x12 x13 x15 cd cs = case x15 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    x13 (d_OP_makeModule_dot_uscore_hash_lambda49 x12 x14 x2 x8 x6 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x3 x6 x8 x2
    x14 x12 x13 l cd cs) (d_C__case_26 x3 x6 x8 x2 x14 x12 x13 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x3
    x6 x8 x2 x14 x12 x13 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_26 x3 x6 x8 x2
    x14 x12 x13 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_26"
    [show x3, show x6, show x8, show x2, show x14, show x12, show x13, show x15]
    info)
  _ -> failCons cd (consFail "Compile._case_26" (showCons x15))

nd_C__case_26 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_TransFunctions.C_State -> Curry_Prelude.C_Int
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_TransFunctions.C_State
nd_C__case_26 x3 x6 x8 x2 x14 x12 x13 x15 s cd cs = case x15 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    x13 (wrapNX id (nd_OP_makeModule_dot_uscore_hash_lambda49 x12 x14 x2 x8 x6
    x3)) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x3 x6 x8 x2
    x14 x12 x13 l s cd cs) (nd_C__case_26 x3 x6 x8 x2 x14 x12 x13 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x3
    x6 x8 x2 x14 x12 x13 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_26 x3 x6 x8 x2
    x14 x12 x13 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_26"
    [show x3, show x6, show x8, show x2, show x14, show x12, show x13, show x15]
    info)
  _ -> failCons cd (consFail "Compile._case_26" (showCons x15))

d_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C__case_30 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.d_C_foldIO (acceptCs id (d_C_makeModule x3)) x1
    (Curry_Prelude.d_C_zip x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
    cd cs) (Curry_Prelude.C_Int (1)) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_done cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO_
    Curry_Message.d_C_putErrLn cd cs) x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x4 x3 x1 l cd
    cs) (d_C__case_30 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_30 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_30"
    [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Compile._case_30" (showCons x5))

nd_C__case_30 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_TransFunctions.C_State
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
nd_C__case_30 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldIO (wrapDX (wrapNX id)
    (acceptCs id (nd_C_makeModule x3))) x1 (Curry_Prelude.d_C_zip x3
    (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
    cd cs)) (Curry_Prelude.C_Int (1)) s0 cd cs) cd cs) s1 cd cs))
    (Curry_Prelude.d_C_done cd cs) s3 cd cs))
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_mapIO_
    (wrapDX id Curry_Message.d_C_putErrLn) s0 cd cs) x4 s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_30 x4 x3 x1 l s
    cd cs) (nd_C__case_30 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_30 x4
    x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_30 x4 x3 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Compile._case_30"
    [show x4, show x3, show x1, show x5] info)
  _ -> failCons cd (consFail "Compile._case_30" (showCons x5))

d_C__case_31 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> Cover -> ConstStore -> Curry_TransFunctions.C_State
d_C__case_31 x1 x12 cd cs = case x12 of
  Curry_TransFunctions.C_State x4 x5 x6 x7 x8 x9 x10 x11 -> Curry_TransFunctions.C_State
    x4 x5 x6 x7 x8 x9 x10 x1
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (d_C__case_31 x1 l
    cd cs) (d_C__case_31 x1 r cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    d_C__case_31 x1 z cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (d_C__case_31 x1 e
    cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_31" [show x1, show x12] info)
  _ -> failCons cd (consFail "Compile._case_31" (showCons x12))

nd_C__case_31 :: Curry_CompilerOpts.C_Options -> Curry_TransFunctions.C_State
  -> IDSupply -> Cover -> ConstStore -> Curry_TransFunctions.C_State
nd_C__case_31 x1 x12 s cd cs = case x12 of
  Curry_TransFunctions.C_State x4 x5 x6 x7 x8 x9 x10 x11 -> Curry_TransFunctions.C_State
    x4 x5 x6 x7 x8 x9 x10 x1
  Curry_TransFunctions.Choice_C_State d i l r -> narrow d i (nd_C__case_31 x1 l
    s cd cs) (nd_C__case_31 x1 r s cd cs)
  Curry_TransFunctions.Choices_C_State d i xs -> narrows cs d i (\z ->
    nd_C__case_31 x1 z s cd cs) xs
  Curry_TransFunctions.Guard_C_State d c e -> guardCons d c (nd_C__case_31 x1 e
    s cd $! addCs c cs)
  Curry_TransFunctions.Fail_C_State d info -> failCons d (traceFail
    "Compile._case_31" [show x1, show x12] info)
  _ -> failCons cd (consFail "Compile._case_31" (showCons x12))

d_C__case_32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_CompilerOpts.C_Options -> Cover -> ConstStore
  -> Curry_CompilerOpts.C_Options
d_C__case_32 x1 x2 x4 cd cs = case x4 of
  Curry_CompilerOpts.C_Opts x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 -> Curry_CompilerOpts.C_Opts
    x6 x7 x8 (Curry_CompilerOpts.d_C_optVerbosity x4 cd cs) x10 x11 x12 x13 x14
    x15 x16 x17 (Curry_RCFile.d_C_updateRCDefs x2 (Curry_Prelude.d_C_snd
    (Curry_RCFile.d_C_extractRCArgs x1 cd cs) cd cs) cd cs)
  Curry_CompilerOpts.Choice_C_Options d i l r -> narrow d i (d_C__case_32 x1 x2
    l cd cs) (d_C__case_32 x1 x2 r cd cs)
  Curry_CompilerOpts.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_32 x1 x2 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Options d c e -> guardCons d c (d_C__case_32 x1 x2
    e cd $! addCs c cs)
  Curry_CompilerOpts.Fail_C_Options d info -> failCons d (traceFail
    "Compile._case_32" [show x1, show x2, show x4] info)
  _ -> failCons cd (consFail "Compile._case_32" (showCons x4))

